/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* link on conditions on influences. */

#ifndef CONDVAR_H
#define CONDVAR_H

#include "../caen/caen-runt.h"
#include "StateVar.h"
#include <string>
#include <set>
#include <map>

class CondVar : public StateVar {
 public:
  multimap<const char*, int>* conditions; /**< store atom name / place of its related condition in the runtime (condi). */

  CondVar(string name, set<string> se, string defa, Comp* co); //non observable.
  CondVar(string name, set<string> se, string defa, Comp* co, bool obs); //define also observability.
  CondVar();
  ~CondVar();
};
#endif
