/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Variables that are not modes, and not commands. */

#ifndef DEPENDENTVAR_H
#define DEPENDENTVAR_H

#include "caen-runt.h"
#include "StateVar.h"
#include <string>
#include <set>

class DependentVar : public StateVar {
  multimap<const char*, int>* conditions; /**< store atom name / place of its related condition in the runtime (condi). */

 public:
  DependentVar(string name, set<string> se, string defa, Comp* co); //non observable.
  DependentVar(string name, set<string> se, string defa, Comp* co, bool obs); //define also observability.
  DependentVar();
  ~DependentVar();
};

#endif
  
