/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "Formula.h"
#include <iostream>

/* Functions for class Formula */

//constructor
Formula::Formula() {
  pre = NULL;
  post_state = NULL;
  post_form = NULL;
}
Formula::Formula(StateFormula* pr, StateFormula* po, vector<Formula*>* po_frm) {
  pre = pr;
  post_state = po;
  post_form = po_frm;
}

Formula::Formula(StateFormula* pr, StateFormula* po, vector<Formula*>* po_frm, bool flag) {
  pre = pr;
  post_state = po;
  post_form = po_frm;
  //add a reference in each premisse's atoms
  /*if (flag==1)
    addRefToAtoms(this);*/
}
//destructor
Formula::~Formula() {
  delete pre;
  pre = 0;
  delete post_state;
  post_state = 0;
  if (post_form != NULL) //added
    purge(*post_form);
  delete post_form;
  post_form = 0;
}
//reference the formula to its atoms
/*void Formula::addRefToAtoms(Formula* frm) {
  vector<Atom*>* temp_pre;
  vector<Atom*>* temp_post;
  if (pre != NULL) {
    temp_pre = pre->getAllAtoms();
    for (unsigned int i=0; i<temp_pre->size(); i++) {
      (*temp_pre)[i]->addRefConstPre(frm);
    }
    delete temp_pre;
  }
  if (post_state != NULL) {
    temp_post = post_state->getAllAtoms();
    for (unsigned int k=0; k<temp_post->size(); k++) {
      (*temp_post)[k]->addRefConstPost(frm);
    }
    delete temp_post;
  }
  if (post_form!=NULL) {
    for (unsigned int j=0; j<post_form->size(); j++)
      (*post_form)[j]->addRefToAtoms(this);
      }
  }*/
/* add a formula to post. */
void Formula::addFormula(Formula* form) {
  post_form->push_back(form);
}

string Formula::getOperat () {
   return operat;
}

void Formula::setOperat (string op) {
   operat = op;
}
  
////show the formula
void Formula::showFormula() {
  if (pre != NULL) {pre->showStateFormula();
  cout << " => ";
  }
  if (post_state != NULL)
    post_state->showStateFormula();
  if (post_form!=NULL) {
    for (unsigned int i=0; i<post_form->size(); i++) {
      //cout << "(";
      (*post_form)[i]->showFormula();
      //cout << ")";
      if (i != post_form->size() - 1) cout << "\t\t";
    }
    return;
  }
  cout << endl;
}
