
/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef FORMULA_H
#define FORMULA_H

#include "StateFormula.h"
#include <vector>
#include "../system/purge.h"

/**
 * \class Formula
 * \brief Formula : StateFormula => StateFormula express a component behavior.
 */

class Formula {
 public:
  string operat; // and/or (only if post_form != NULL)
  StateFormula* pre;
  StateFormula* post_state;
  vector<Formula*>* post_form;

 public:
  Formula();
  Formula(StateFormula* pr, StateFormula* po, vector<Formula*>* po_frm);
  Formula(StateFormula* pr, StateFormula* po, vector<Formula*>* po_frm, bool flag); //flag is to choose to add to atoms or not...
  ~Formula();
  /*void addRefToAtoms(Formula* frm);*/ //reference the formula to its atoms
  void addFormula(Formula* form);
  void setSupports(); //set the support to the post atoms and update pre atoms 'supported'.
  string getOperat ();
  void setOperat (string op);
  void showFormula();

};

#endif
