/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Variable that corresponds to an assignment by the running process (sensors, internal software, etc...)
=> observations variables for model-based diagnosis
*/

#ifndef OBSVAR_H
#define OBSVAR_H

#include "DependentVar.h"
#include <string>
#include <set>

class ObsVar : public DependentVar {
  
 public:
  string real_value; //value of the 'real' system (from the sensor).
  ObsVar(string name, set<string> se, string defa, Comp* co);
  ObsVar(string name, set<string> se, string defa, Comp* co, string rv);
  ObsVar();
  bool matchObs(); //compare the value with the observation from the spacecraft.

};

#endif
  
