/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "ObsVarrt.h"

using namespace std;

/* Functions for class ObsVar */

//constructors
ObsVar::ObsVar(string name, set<string> se, string defa, Comp* co) : DependentVar(name, se, defa, co) {
  type = "Observable";
  real_value = "";
}
ObsVar::ObsVar(string name, set<string> se, string defa, Comp* co, string rv) : DependentVar(name, se, defa, co) {
  type = "Observable";
  real_value = rv;
}
ObsVar::ObsVar() : DependentVar() {
  type = "Observable";
}
//compare the value with the observation from the spacecraft.
bool ObsVar::matchObs() {
  if (real_value != "") 
    return (getCurrentState()==real_value);
  else return true;
}

