/*
 * Parser for CaNF models.
 * Benazera Emmanuel - LAAS-CNRS / DISCO - May 2001.
 */

letter  [a-z_A-Z]
digit   [0-9]

%{
#include <string>
#include <vector>
#include "Atom.h"
#include "caen-objet.h"
#include "../system/config.h"
#include "ModelHybridParser.yy.cc.h"

  string type_others;
  vector<string> values; /**< temporary storage of state variables values. */
%}

%option yylineno

%{
  char buf[100], buf1[100], buf2[100], buf_use[100];
  char *s, *s1, *s2, *s_use;
%}

%x COMMENTARY
%x DECLARATIONS
%x ARGS
%x CLASS

%%

"/*"			{BEGIN COMMENTARY;} 
<COMMENTARY>"*/" 	{BEGIN 0;}
<COMMENTARY>"\n"
<COMMENTARY>.		;



"uses" {
  s_use = buf_use;
  ModelHybridParserlval.declarations = new vector<string>();
  BEGIN DECLARATIONS;
}

<DECLARATIONS>{letter}|{digit} {*s_use++ = *yytext;}
<DECLARATIONS>","        {
			  *s_use++ = '\0';
			  ModelHybridParserlval.declarations->push_back(string(buf_use));
			  *s_use=0;
			  s_use = buf_use;
                         }
<DECLARATIONS>";" {
  *s_use++ = '\0';
  ModelHybridParserlval.declarations->push_back(string(buf_use));
  *s_use=0;
  BEGIN 0;
  return USE;
}
<DECLARATIONS>. ;

"(" {
  s1 = buf1;
  ModelHybridParserlval.args = new vector<string>();
  BEGIN ARGS;
}
<ARGS>{letter}|{digit}|"."|"_" {*s1++ = *yytext;}
<ARGS>"," {
    *s1++ = '\0';
    ModelHybridParserlval.args->push_back(string(buf1));
    *s1 = 0;
    s1 = buf1;
}
<ARGS>")" {
  *s1++ = '\0';
  ModelHybridParserlval.args->push_back(string(buf1));
  *s1 = 0;
  BEGIN 0;
  return ARGUMENTS;
}
<ARGS>. ;

"<" {
  s2 = buf2;
  BEGIN CLASS;
}
<CLASS>{letter}|{digit}|"_" {*s2++ = *yytext;}
<CLASS>">" {
  *s2++ = '\0';
  *s2 = 0;
  ModelHybridParserlval.type = mkString (buf2);
  BEGIN 0;
  return TYPE;
}
<CLASS>. ;

[ \t]                   ;
"{"                     {return LB;}
"}"                     {return RB;}
"\n"                      ;
. {return ModelHybridParsertext[0];}

({letter}({letter}|"."|"_"|{digit})*) {
  ModelHybridParserlval.var = new string(yytext);
  return VARIABLE;
}

%%

int ModelHybridParserwrap(void) {
  return 1;
}

int ModelHybridParserln() {
  return ModelHybridParserlineno;
  return 1;
}
