/* $Header: /home/ebenazer/cvsroot/koala/compiler/Attic/varsHybridParser.lex,v 1.1.2.15 2003/04/07 16:27:34 ebenazer Exp $
 * Emmanuel Benazera - LAAS-CNRS / DISCO / Toulouse - 2001
 */
letter  [a-z_A-Z]
digit   [0-9]
E      [digitEdigite][+-]?{digit}+

%{

#include "../behav/StateVar.h"
#include "../behav/ModeVar.h"
#include "../behav/ObsVar.h"
#include "../behav/CommandVar.h"
#include "../behav/DependentVar.h"
#include "../behav/Comp.h"
#include <stdio.h>
#include "string.h"
#include <stdlib.h>
#include <iostream.h>
#include <map>
#include "varsHybridParser.yy.cc.h"

/*#define YY_USER_INIT yyin=varsHybridParserlval.decl_input;*/

  extern string type_others;
  extern vector<string> values; /**< temporary storage of state variables values. */ 
  extern string comp_var_name;
  Atom* at1;
%}

%{
  extern arDef conSymb;
  extern char* nomComp;
  extern arDef symCons;
  extern char *nom, *txt;
  extern char buf[100], buf1[100], buf2[16], buf_use[32];
  extern char *s, *s1, *s2, *s_use;
  extern char *S1;
%}

%option yylineno
%option yywrap

%x STRING
%x COMMENTARY
%x STATE_VAR
%x MODE_VAR
%x OBS_VAR
%x COMMAND_VAR
%x DEPENDENT_VAR
%x MODALITIES
%x SHARED_VAL
%x SHARED_INIT
%x OTHERS_PARSE
%x DECLARATIONS
%x VAR

%%

"/*"			{BEGIN COMMENTARY;} 
<COMMENTARY>"*/" 	{BEGIN 0;}
<COMMENTARY>"\n"
<COMMENTARY>.     

\"                	{ BEGIN STRING; s = buf; }
<STRING>\\n       	{ *s++ = '\n';}
<STRING>\\t       	{ *s++ = '\t';}
<STRING>\\\"      	{ *s++ = '\"';}
<STRING>\"        	{ *s++ = '\0';*s = 0;
                    	BEGIN 0;	
		    	varsHybridParserlval.name = buf;
		    	return STR;
                  	}
<STRING>"\n"            ;
<STRING>.         	{ *s++ = *yytext; }

"uses" {
  s_use = buf_use;
  varsHybridParserlval.declarations = new vector<string>();
  BEGIN DECLARATIONS;

}

<DECLARATIONS>{letter}|{digit} {*s_use++ = *yytext;}
<DECLARATIONS>","        {
			  *s_use++ = '\0';
			  varsHybridParserlval.declarations->push_back(string(buf_use));
			  *s_use=0;
			  s_use = buf_use;
                         }
<DECLARATIONS>";" {
  *s_use++ = '\0';
  varsHybridParserlval.declarations->push_back(string(buf_use));
  *s_use=0;
  BEGIN 0;
  return USE;
}
<DECLARATIONS>[ \t] ;
<DECLARATIONS>.

"others: " {
  BEGIN OTHERS_PARSE;
}

<OTHERS_PARSE>{letter}|{digit} {
}
<OTHERS_PARSE>";" {
  BEGIN 0;
  return IMPORT;
}
<OTHERS_PARSE>[, \t] ;
<OTHERS_PARSE>.

"shared" {
  varsHybridParserlval.shared= new vector<string>();
  s1 = buf1;
  BEGIN SHARED_INIT;
}
<SHARED_INIT>"(" { 
  s1 = buf1;
  BEGIN SHARED_VAL;
} 
<SHARED_VAL>"%"|{letter}|{digit}		{*s1++ = *yytext;}
<SHARED_VAL>","			{
  *s1++ = '\0';
  varsHybridParserlval.shared->push_back(string(buf1));
  *s1=0;s1 = buf1;}
<SHARED_VAL>")"			{
  *s1++ = '\0';
  varsHybridParserlval.shared->push_back(string(buf1));
  *s1=0;
  BEGIN 0;
  return SHARED;
}
<SHARED_VAL>[ \t] ;
<SHARED_VAL>.

"ModeVar"		{
  varsHybridParserlval.modevar = new ModeVar();
  values = vector<string>();
  s = buf;
  s2 = buf2;
  s2 = "Mode";
  BEGIN MODE_VAR;
}
<MODE_VAR>";"		{
  BEGIN 0;
  *s++='\0';
  varsHybridParserlval.modevar->setName((comp_var_name + "." + string (buf)).c_str ());
  varsHybridParserlval.modevar->setSymbName (string (buf));
  for (unsigned int i=0; i<values.size(); i++) {
    varsHybridParserlval.modevar->addValue(values[i]);
    at1 = new Atom(varsHybridParserlval.modevar, values[i], varsHybridParserlval.modevar->name + "=" + values[i], false);
  }
  varsHybridParserlval.modevar->default_state = values[0];
  varsHybridParserlval.modevar->current_state = &varsHybridParserlval.modevar->default_state;
  return MODEVAR;
}	
<MODE_VAR>"("		{
  BEGIN MODALITIES;
  s1 = buf1;
}
<MODE_VAR>[^ \t]		{*s++ = *yytext;}

"ObsVar"		{
  varsHybridParserlval.obsvar = new ObsVar();
  values = vector<string>();
  s = buf;
  s2 = buf2;
  s2 = "Observable";
  BEGIN OBS_VAR;
}
<OBS_VAR>";"		{
  BEGIN 0;
  *s++='\0';
  varsHybridParserlval.obsvar->setName((comp_var_name + "." + string (buf)).c_str ());
  varsHybridParserlval.obsvar->setSymbName (string (buf));
  for (unsigned int i=0; i<values.size(); i++) {
    varsHybridParserlval.obsvar->addValue(values[i]);
    at1 = new Atom(varsHybridParserlval.obsvar, values[i], varsHybridParserlval.obsvar->name + "=" + values[i], false);
  }
  varsHybridParserlval.obsvar->default_state = values[0];
  varsHybridParserlval.obsvar->current_state = &varsHybridParserlval.obsvar->default_state;
  return OBSVAR;
}	
<OBS_VAR>"("		{
  BEGIN MODALITIES;
  s1 = buf1;
}
<OBS_VAR>[^ \t]		{*s++ = *yytext;}

"CommandVar"		{
  varsHybridParserlval.cmdvar = new CommandVar();
  values = vector<string>();
  s = buf;
  s2 = buf2;
  s2 = "Command";
  BEGIN COMMAND_VAR;
}
<COMMAND_VAR>";"		{
  BEGIN 0;
  *s++='\0';
  varsHybridParserlval.cmdvar->setName((comp_var_name + "." + string (buf)).c_str ());
  varsHybridParserlval.cmdvar->setSymbName (string (buf));
  for (unsigned int i=0; i<values.size(); i++) {
    varsHybridParserlval.cmdvar->addValue(values[i]);
    at1 = new Atom(varsHybridParserlval.cmdvar, values[i], varsHybridParserlval.cmdvar->name + "=" + values[i], false);
  }
  varsHybridParserlval.cmdvar->default_state = values[0];
  varsHybridParserlval.cmdvar->current_state = &varsHybridParserlval.cmdvar->default_state;
  return COMMANDVAR;
}	
<COMMAND_VAR>"("		{
  BEGIN MODALITIES;
  s1 = buf1;
}
<COMMAND_VAR>[^ \t]		{*s++ = *yytext;}

"DependentVar"		{
  varsHybridParserlval.depvar = new DependentVar();
  values = vector<string>();
  s = buf;
  s2 = buf2;
  s2 = "Dependent";
  BEGIN DEPENDENT_VAR;
}
<DEPENDENT_VAR>";"		{
  BEGIN 0;
  *s++='\0';
  varsHybridParserlval.depvar->setName((comp_var_name + "." + string (buf)).c_str ());
  varsHybridParserlval.depvar->setSymbName (string (buf));
  for (unsigned int i=0; i<values.size(); i++) {
    varsHybridParserlval.depvar->addValue(values[i]);
    at1 = new Atom(varsHybridParserlval.depvar, values[i], varsHybridParserlval.depvar->name + "=" + values[i], false);
  }
  varsHybridParserlval.depvar->default_state = values[0];
  varsHybridParserlval.depvar->current_state = &varsHybridParserlval.depvar->default_state;
  return DEPENDENTVAR;
}	
<DEPENDENT_VAR>"("		{
  BEGIN MODALITIES;
  s1 = buf1;
}
<DEPENDENT_VAR>[^ \t]	{*s++ = *yytext;}

<MODALITIES>{letter}|{digit}|("+"|"-")		{*s1++ = *yytext;}
<MODALITIES>[ \t] ;
<MODALITIES>","		{*s1++ = '\0';
 values.push_back(string(buf1));*s1=0;s1 = buf1;}
<MODALITIES>")"			{*s1++ = '\0';
 values.push_back(string(buf1));*s1=0;
 if (strcmp(s2, "Mode") == 0) BEGIN MODE_VAR;
 else if (strcmp(s2, "Command") == 0) BEGIN COMMAND_VAR;
 else if (strcmp(s2, "Dependent") == 0) BEGIN DEPENDENT_VAR;
 else if (strcmp(s2, "Observable") == 0) BEGIN OBS_VAR;
}

[ \t]                 ;
"=>"         		{return IMP;}
"|"			{return OR;}
"&"			{return AND;}
"cin"                   {return CIN;}
"cout"                  {return COUT;}
"="                     {varsHybridParserlval.OpRel=EQ; return OPREL;}
"!="                    {varsHybridParserlval.OpRel=NE; return OPREL;}
"\<="                   {varsHybridParserlval.OpRel=LE; return OPREL;}
"\<"                    {varsHybridParserlval.OpRel=LT; return OPREL;}
"\>="                   {varsHybridParserlval.OpRel=GE; return OPREL;}
"\>"                    {varsHybridParserlval.OpRel=GT; return OPREL;}
"+oo"                   {return PLUSINF;}
"-oo"                   {return MOINSINF;}
"\*\*"|"\^"             {return EXPO;}
"boolean"|"BOOLEAN"     {return BOOL;}
"CondVar"               {return CONDVAR;}
"condition"|"CONDITION" {return COND;}
"delay"|"DELAY"         {varsHybridParserlval.CoefType=DELAY; return COEFTYPE;}
"display"|"DISPLAY"     {varsHybridParserlval.InterType=DISPLAY; return INTERFACE;}
"false"|"FALSE"         {varsHybridParserlval.String = mkString (varsHybridParsertext);
                         return BOOLEEN;}
"gain"|"GAIN"           {varsHybridParserlval.CoefType=GAIN; return COEFTYPE;}
"exo"                   {return EXO;}
"xi"|"XI"               {varsHybridParserlval.CoefType=XI; return COEFTYPE;}
"w"|"W"                 {varsHybridParserlval.CoefType=PULSE; return COEFTYPE;}
"n1"|"N1"               {varsHybridParserlval.CoefType=N1; return COEFTYPE;}
"n2"|"N2"               {varsHybridParserlval.CoefType=N2; return COEFTYPE;}
"a0"|"A0"               {varsHybridParserlval.CoefType=A0; return COEFTYPE;}
"a1"|"A1"               {varsHybridParserlval.CoefType=A1; return COEFTYPE;}
"a2"|"A2"               {varsHybridParserlval.CoefType=A2; return COEFTYPE;}
"-D->"                  {varsHybridParserlval.InfluType=DINFL; return INFLUES;}
"-D2->"                 {varsHybridParserlval.InfluType=D2INFL; return INFLUES;}
"-I->"                  {varsHybridParserlval.InfluType=IINFL; return INFLUES;}
"-S->"                  {varsHybridParserlval.InfluType=SINFL; return INFLUES;}
"-C->"                  {varsHybridParserlval.InfluType=CINFL; return INFLUES;}
"c+"                    {return CPLUS;}
"c-"                    {return CMIN;}
"in"|"IN"               {varsHybridParserlval.OpRel=(opRel)IN; return OPREL;}
"init"|"INIT"           {return INIT;}
"input"|"INPUT"         {varsHybridParserlval.InterType=INPUT; return INTERFACE;}
"instance"|"INSTANCE"   {return INSTANCE;}
"measure"|"MEASURE"     {varsHybridParserlval.InterType=MEASURE; return INTERFACE;}
"model"|"MODEL"         {return MODELE;}
"parameter"|"PARAMETER" {return PARAMETER;}
"resptime"|"RESPTIME"   {varsHybridParserlval.CoefType=RESPTIME; return COEFTYPE;}
"true|TRUE"             {varsHybridParserlval.String = mkString (varsHybridParsertext);
                               return BOOLEEN;}
"variable"|"VARIABLE"   {return VARIABLEDEF;}

"mapfunc" | "MAPFUNC"   {return MAPFUNC;}
"constraints"           {return CONSTRAINTS;}
"transitions"           {return TRANSITIONS;}
"vardef"                {return VARDEF;}
"Component"	 	{return COMPONENT;}
"Next"			{return NEXT;}
"Nominal"               {return NOMINAL;}
"Idle"                  {return IDLE;}
"Fail"                  {return FAIL;}
"VarAssign"             {return VARASSIGN;}

[a-zA-Z][._0-9a-zA-Z]* {
  nom = buf;
  char* tok;
  tok = strtok (mkString (varsHybridParsertext), ".");
  if ((strtok (NULL, ".") == NULL)
      && (strcmp (varsHybridParsertext, "FALSE"))
      && (strcmp (varsHybridParsertext, "false"))
      && (strcmp (varsHybridParsertext, "TRUE"))
      && (strcmp (varsHybridParsertext, "true"))) {
    strcpy (nom, comp_var_name.c_str ());
    strcat (nom, ".");
    strcat (nom, varsHybridParsertext);
    conSymb = searchDef (&symCons, nom);
    if (isNull (conSymb)) {
      varsHybridParserlval.var = mkString (nom);
      return VARIABLE;
    }
  }
  else {
    conSymb = NULL;
    varsHybridParserlval.var = "";/*mkString (varsHybridParsertext);*/
    free (tok);
    return VARIABLE;}
  if (! isNull (conSymb)) {
    varsHybridParserlval.var = txt = getArDefTxt (conSymb);
    if ((! strcmp (txt, "FALSE"))
	|| (! strcmp (txt, "false"))
	|| (! strcmp (txt, "TRUE"))
	|| (! strcmp (txt, "true")))
    {return BOOLEEN;}
    else if (isalpha (txt[0]))
    {return VARIABLE;}
    else
    {return REEL;}}}

{digit}+                |
{digit}+"."{digit}*({E})?   |
{digit}*"."{digit}+({E})?   |
{digit}+{E}             {varsHybridParserlval.String = mkString (varsHybridParsertext); return REEL;}
"\n"                  ;
.            		{return varsHybridParsertext[0];} 

%%

int varsHybridParserwrap(void) {
  varsHybridParserlineno = 1;
  return 1;
}

int varsHybridParserln() {
  return varsHybridParserlineno;
}
