/* koala-super.cpp */
#include "koala-super.h"

/* super-level temporaries, for macro calls only */
long L1;
valeur Vl1;
char * S1;
range Rn1;
objet Obj1;
domain Dom1;
listcaenCoef Lc1;
paramFor Pf1;
listcaenParFor Lf1;
paramEff Pe1;
listcaenParEff Le1;
cond Cn1;
listcaenInfl Lif1;
expr Ex1;
listcaenInitVar Liv1;
gVar Gv1;
listcaenGVar Lg1;
listcaenLong Ll1;
listcaenExpr Lex1;

/*#ifdef DEBUG
extern long memAl;
extern long memFr;
#endif*/

/* parser, data structures generator */
FILE *mainSource, *runBuild;
char *saux;
char bufErr[100];
enum boolVal bval;
long recover;
vector<cond>* condis;
vector<cond>* conditions;
vector<StateFormula*>* stfs;

long nlIns;                                         /* para hacer callar ld  */
enum ordre ordIns = DEBUT;
char cePath[80], msg[20], msg1[20];
char CDir[80], ceBinDir[80], ceIncDir[80], ceLibDir[80],
  apBinDir[80], behDir[80], itmsDir[80], sysDir[80], figDir[80];
char exeFile[80], exeName[80], exeRtFile[80], mainCFile[80],
  runBuildFile[80], auxFile[80], leFile[80],
  runExFile[80], param1[40], param3[40], param2[40], param4[40];
char *param[4] = {param1, param2, param3, param4};
char commande[800];
char commande2[800];
char *caenDir, *hostType;
long loaded=0, compiled=0, executed=0;
long guards_int=0;                  /* transitions guards on non measured interval value */
vector<string>* generated_types;
char* mdlfile;
vector<component>* comps;
string cl_header = "";
vector<string>* cl_files = new vector<string> ();
const char* usage = "Usage: koala (-{hyb,cont,disc}) <file.mdl>"; 

const char* printDoc = "Print data structures:\n\t\tdic\tprint continuous variables\n\t\tinf\tinfluences\n\t\tcond\tconditions defined in discrete variables\n\t\tco\tlist of components in the model\n\t\tco + name\tcomponent variables, constraints and transitions\n\t\ttoms\tall boolean propositions in the model (compiled model only)\n\t\tgra\tcausal graph (compiled model only)\n\t\tupd\tupdating sequence\n\t\tglo\tglobal constraints\n\t\tcdc\tconditions as constraints\n\t\tinit\tinitializations\n";

#ifdef HAVE_DOT
const char* graphDoc = "make figures of causal graph and components:\n\t\tcg\tcausal graph\n\t\t<comp> component\n";
#endif /* HAVE_DOT */

ceCom cde [] = {
  {"quit", ceQuit, "Quit Koala"},
  {"q", ceQuit, "shortcut to quit"},
  {"help", ceHelp, "Get Help"},
  {"#", ceComment, "Comment line"},
  {"load", ceLoad, "Load an application"},
  {"compile", ceCompile, "Compile and generate C code"},
  {"execute", ceExec, "Launch runtime"},
  {"exec", ceExec, "shortcut to execute"},
  {"print", cePrint, printDoc},
  {"p", cePrint, "shortcut to print"},
#ifdef HAVE_DOT
  {"graph", ceGraph, graphDoc},
  {"g", ceGraph, "shortcut to graph"},
#endif /* HAVE_DOT */
  {"reload", ceReload, "Load same application again"},
  {"unload", ceUnload, "Unload an application"},
  {"system", ceSystem, "Issue a shell command"},
  {"options", ceOptions, "Option menu"},
  {(char *) NULL, (LFunction *) NULL, (char *) NULL}
};


int main (int argc, char *argv[]) {
  char * t;
  ceCom *pc;
  char *pigne, *migne;
  
  objInit ();
#ifdef DEBUG
  memInit ();
#endif /* DEBUG */
  if ((caenDir = getenv ("KOALADIR")) == NULL) {
    fprintf (stdout, "Environment variable KOALADIR not set !\n");
    exit (0);
  }
  
  /* grab a hostType variable similar as the one from configure script (needs config.guess)*/
  char bufhost[1024];
  FILE* conff;
  char bufconfig[100];
  strcpy (bufconfig, caenDir);
  strcat (bufconfig, "/config.txt");
  /*if ((conff = fopen ("config.txt", "r")) == NULL) {
    if (-1 == system ("../../config.guess > config.txt")) {
    fprintf (stderr, "guessing the hostType failed. Be sure you have config.guess in the koala directory's root\n");
      exit (0);
      }
      }*/
  if ((conff = fopen (bufconfig, "r")) == NULL) {
    fprintf (stderr, "Can't find config.txt\n");
    exit (0);
  }
  if (fgets(bufhost, 1024, conff) != NULL) {
    if ((hostType = strchr (bufhost,'\n')) == NULL)
      fprintf (stderr, "Error while reading config.txt");
    *hostType = '\0';
    hostType=bufhost;
  }
  fclose (conff);
  
  fprintf(stdout, "%s\n",hostType);
  strcpy (ceBinDir, caenDir);
  strcat (ceBinDir, "/bin/");
  strcat (ceBinDir, hostType);
  strcat (ceBinDir, "/");
  strcpy (cePath, ceBinDir);
  strcat (cePath, KOALANAME);          /* pathname de koala, pour unload  */
  ligneInit ();
  load_conf_file ();
  if (argc == 1)            {        /* no arg */
    char artbuf[50000];
    FILE* koala_stream;
    char koala_art_filename[10];
    strcpy(koala_art_filename, caenDir);
    strcat(koala_art_filename, "/koala.art");
    cout << koala_art_filename << endl;
    if ((koala_stream = fopen(koala_art_filename, "r")) == NULL) {
      fprintf (stdout, "Failed opening the logo\n");
      exit (1);
    }
    while (fgets(artbuf, 1024, koala_stream) != NULL) {
      fprintf (stdout, artbuf);
    }
    fprintf (stdout, "\n\n");
    fclose(koala_stream);
  }
  else if (argc == 2) {
    if (strcmp (argv[1], "-h") == 0 || strcmp (argv[1], "--help") == 0) {
      printf ("%s\n", usage);
      exit (0);
    }
    if (strcmp (argv[1], "new")) /* new koala session otherwise unload. */
      ceLoad (argv[1]);                    /* hybrid as default mode. */ 
    else printf ("Wrong option or source file name: %s\n%s\n", argv[1], usage);
  }
  else if (argc == 3) {
    if (strcmp (argv[1], "-hyb") == 0) {
      printf ("Hybrid mode activated\n");
    }
    else if (strcmp (argv[1], "-cont") == 0) {
      conf_set("hybrid", 0);
      conf_set("discrete", 0);
      conf_set("continuous", 1);
      printf ("Continuous mode only\n");
    }
    else if (strcmp (argv[1], "-disc") == 0) {
      conf_set("hybrid", 0);
      conf_set("discrete", 1);
      conf_set("continuous", 0);
      printf ("Discrete mode only\n");
    }
    else {
      printf ("Wrong argument: %s\n%s\n", argv[1], usage);
      exit (1);
    }
    if (strcmp (argv[2], "new"))        /* new koala session otherwise unload. */
      ceLoad (argv[2]);                 /* hybrid as default mode. */ 
  }
  
  while (! done) {
    if (! isNull (migne = do_gets ("> "))) {
      pigne = migne;
      if (*pigne == '\0')                             /* linea vacia         */
	continue;
      if (! (isatty (0) && isatty (1)))
	fprintf (stdout, "%s\n", pigne);              /* solo si redireccion */
      if (*pigne == '#')                              /* comentario          */
	continue;
      stripWhite (pigne);     /* tira los ' ' y '\t' del principio y del fin */
      t = strtok (pigne, " ");
      pc = whichCom (cde, t);
      if (isNull (pc)) {
	fprintf (stdout, "%s: Unknown Koala command.\n", t);
	continue;
      }
      t = strtok (NULL, "");
      stripWhite (t);
      (*(pc->func)) (t);
    }
  } /* end while ! done */
  fprintf (stdout, "Leaving Koala.\n");
  exit (0);
}

/* 1. Load an application -----------------------------------------------*/

long ceLoad (char *arg) {
  char *s, *t;
  struct stat binStat, tmpDirStat;
  long ok;

  fprintf (stdout, "Loading %s\n", arg);
 
  inputListcaen=displayListcaen=measureListcaen=temporalListcaen=untemporalListcaen=NULL;
  influListcaen=NULL;
  gVarListcaen=NULL;
  globCListcaen=NULL;
  condCListcaen=NULL;
  initListcaen=NULL;
  sommetS=NULL, sommetP=NULL;
  dictionary=NULL;
  symCons = NULL;
  numCstVar = loadError = recover = 0;
  nInterm = 0;

  if (loaded) {
    fprintf (stdout, "Please unload %s first !\n", appliName);
    return 0;
  }
  if (isNull (arg) || (*arg == '\0') || (*arg == '\n')) {
    fprintf (stdout, "Missing source file name !\n");  /* fichero de entrada */
    return 0;
  }
  strcpy (fileIn, arg);
  if (isNull (s = strstr (fileIn, MDLSUFFIX))
      || (*(s+4) != '\0')) {                          /*    en fin de cadena */
    fprintf (stdout, "Wrong source file name (should be *.mdl)\n");
    return 0;
  }
  strcpy (auxFile, fileIn);
  s = auxFile;
  if (! isNull (t = strtok (auxFile, "/")))
    do
      s = t;
    while (! isNull (t = strtok (NULL, "/")));     /* tira prefijo ...       */
  strncpy (appliPath, fileIn, s-auxFile);         /* ...y ".k" de auxFile    */
  s = strtok (s, ".");                           /* s apunta al nombre sin   */
  stripNumbers (s);                          /* if name begins with a number */
  strcpy (appliName, s);                        /*         prefijo ni sufijo */
  strcpy (tmpDir, appliPath);                  /*construye y comproba nombres*/
  strcat (tmpDir, "tmp/");                    /* de repertorios y ficheros   */
  strcpy (figDir, appliPath);
  strcat (figDir, "fig/");                    /* directory for figures */
  if (stat (tmpDir, &tmpDirStat)) {          /*    que dependen de appliName */
    fprintf (stdout, "No tmp directory. Shouldn't you run koalamkdirs ?\n");
    return 0;
  }
  strcpy (apBinDir, appliPath);
  strcat (apBinDir, "bin/");
  if (stat (apBinDir, &binStat)) {
    fprintf (stdout, "No bin directory. Shouldn't you run caenmkdirs ?\n");
    return 0;
  }
  if ((ModelHybridParserin = mainSource = fopen (fileIn, "r")) == NULL) { /* redirection de yyin*/
    fprintf (stdout, "Can't open file %s\n", fileIn);      /*       vers ce fichier */
    loadError = 1;
  }
  else { /* yyin... */
    nligne = 1;
    braceLevel = 0;
    /* old caen parser. */
    if (conf_get ("continuous") == 1)
      ok = parseContFile(fileIn);                  /* yyparse returns 0 if worked, */
    else {
      /* create discrete structure. */
      reasoner = new itms();
      ok = parseModelFile(fileIn);
    }
    loadError = loadError || ok || recover;     /* 1 if syntax error not recovered */
    fclose (ModelHybridParserin);
    mergeLists ();
    buildGlobCOfGv (gVarListcaen);
    buildCondCOfGv (gVarListcaen);
    if (loadError == 0) {
      /*    if (! isNull (symCons)) {
	    fprintf (stdout, "\n#define:\n");
	    printArDef (symCons);
	    } */
      if (isNull (displayListcaen))
	semError (3, 0, 29);                           /* "no display variable." */
#ifdef DEBUG
      fprintf (stdout, "Load time: %.2f s. ", spentTime ());
      memStats ();
#endif /* DEBUG */
    } /* endif loadError==0 */
  } /* endif yyin... */
  if (! loadError) {
    loaded = 1;
    fprintf (stdout, "Application \"%s\" loaded.\n", appliName);
    compiled = 0;
  }
  else {
    loaded = 0;
    fprintf (stdout, "Unable to load \"%s\"\n", fileIn);
  }
  return loadError;
}


/* 2. caen-compile ----------------------------------------------------*/

long ceCompile (char *s) {
  char *t;
  long i;

  if (! loaded) {
    fprintf (stdout, "Please load application first !\n");
    return 0;
  }
  timeStep = 1.0;
  if (isNull (t = strtok (s, " ")))             /* t: first parameter */
    fprintf (stdout, "Missing time step parameter: 1 assumed.\n");
  else { /* isNull t */
    stripWhite (t);
    if (! isdigit (*t)) 
      fprintf (stdout,
	       "Time step parameter should be a number ! 1 assumed.\n");
    else /* isdigit t */
      timeStep = atof (t);
  } /* endif isNull t */

  reasoner->clauseCompilation ();  /* compile qualitative constraints into clauses. */
  
  /* prime implicants compilation */
  if (pi) {
    enumAllPI (reasoner, pi);
    reasoner->compilePI();
    /*pis->showAllPI ();*/
  }

  buildCGraph (dictionary);
  maxDepth = numTree = 0;
  if (! compCGraphDepths (dictionary))
    return 0;
  if (maxDepth > MAXDEPTHLISTCAEN)
    implError (3);
  for (i=0; i<=maxDepth; i++)
    depthListcaen[i] = NULL;
  sortCGraph (dictionary);
  actCondArrayLength();
  temporalListcaen = depthListcaen[0];
  for (i=1; i<=maxDepth; i++)
    untemporalListcaen = catListcaenVar (untemporalListcaen, depthListcaen[i]);
  checkInits (temporalListcaen);
  strcpy (ceLibDir, caenDir);
  strcat (ceLibDir, "/lib/");
  strcat (ceLibDir, hostType);
  strcpy (ceIncDir, caenDir);
  strcat (ceIncDir, "/include");
  strcpy (behDir, caenDir);
  strcat (behDir, "/behav");
  strcpy (itmsDir, caenDir);
  strcat (itmsDir, "/itms");
  strcpy (sysDir, caenDir);
  strcat (sysDir, "/system");
  strcpy (exeFile, apBinDir);
  strcat (exeFile, appliName);
  strcat (exeFile, "_xe");
  strcpy (exeName, appliName);
  strcat (exeName, "_xe");
  strcpy (runExFile, apBinDir);
  strcat (runExFile, appliName);
  strcat (runExFile, "_rt");
  strcpy (CDir, appliPath);
  strcat (CDir, "C/");
  strcpy (mainCFile, CDir);
  strcat (mainCFile, appliName);
  strcat (mainCFile, ".c");
  
  strcpy (runTDir, appliPath);
  strcat (runTDir, "runtime");
  strcpy (runTFile, runTDir);
  strcat (runTFile, "/");
  strcat (runTFile, appliName);
  strcpy (runTHead, runTFile);
  strcat (runTFile, "_rt.cpp");
  strcat (runTHead, HRTSUFFIX);
  strcpy (runBuildFile, appliPath);
  strcat (runBuildFile, appliName);
  strcat (runBuildFile, BUILDSUFFIX);
  runT = fopen (runTFile, "a");
  runH = fopen (runTHead, "a");

  generated_types = new vector<string>();
  nodestr = initstr = gvarstr = condstr = condcstr = globstr = cross_ref = mfexprstr = "";
  numVar = numNoeud = numCond = numGVar = numGVarSV = numInflu = numInit = numCondC = numGlobC = numMFExpr = 0;
  numVarG = numNoeudG = numInfluG = 0;

  /* generate C++ code of components. */
  for (hash_map<const char*, Comp*, hash<const char*>, eqstr>::iterator comps_it = reasoner->active_comps->begin(); comps_it != reasoner->active_comps->end(); comps_it++) {
    koaGenerateDef (s, (*comps_it).second);
    if (!inVector((*comps_it).second->type, generated_types))
      generated_types->push_back ((*comps_it).second->type);
  }

  if (conf_get ("discrete") == 0)
    koaGenerateRunT ();
  else {  /* no caen runtime is necessary */
    if (cross_ref != "") {    /* cross-reference code */
      fprintf (runT, "/* cross-reference code */\n\t");
      fprintf (runT, cross_ref.c_str ());
    }
    fprintf (runH, "runtime %s_rt;\n", appliName);
    fprintf (runH, "runtime koala_rt;\n");
    fprintf (runT, "%s_rt = NULL;\n", appliName);
    fprintf (runT, "koala_rt = %s_rt;\n", appliName);
    fprintf (runT, "}\nlong guards_int = %ld;\n\t", guards_int);
    fprintf (runT, "int Trajectory::twd = %i;\n\t", twd);
    fprintf (runT, "long h_pi = %ld;\n\t", pi);
    if (koa_evlps_opti)   /* envelopes optimization */
      fprintf (runT, "\nbool env_opti = 1;\n");
    else fprintf (runT, "\nbool env_opti = 0;\n");
    fprintf (runT, "string model_name = \"%s\";\n\t", appliName);

    fclose (runT);
    fclose (runH);
  }

  /* C/C++ compilation */
  /* components compilation */
  for (unsigned int i=0; i<generated_types->size(); i++) {
    if (! koa_code_opti) {
      if (koa_code_debug)
	strcpy (commande, CCEXERTDEB);
      else strcpy (commande, CCEXERT);
    }
    else strcpy (commande, CCEXERTOPT);
    strcat (commande, ceIncDir);
    strcat (commande, " -I");
    strcat (commande, behDir);
    strcat (commande, " -c C/");
    strcat (commande, (*generated_types)[i].c_str());
    strcat (commande, ".cpp");
    timeInit ();
    cout << commande << endl;
    if (0 != system(commande)) {
      fprintf (stdout, "... component %s compilation failed.\n", (*generated_types)[i].c_str());
      return 0;
    }
    /*else {
      fprintf (stdout, "            %s compiled in %.2f s.\n", (*generated_types)[i].c_str(), spentTime ());
      }*/
  }

  /* library */
  strcpy (commande, "ar cr lib");
  strcat (commande, appliName);
  strcat (commande, ".a ");
  for (unsigned int i=0; i<generated_types->size(); i++) {
    strcat (commande, (*generated_types)[i].c_str());
    strcat (commande, ".o ");
  }
  cout << commande << endl;
  if (0 != system(commande)) {
    fprintf (stdout, "... library failed.\n");
  }
  else {
    fprintf (stdout, "            components library completed.\n");
    strcpy (commande, "rm *.o");
    if (0 != system (commande))
      fprintf (stdout, "... error deleting .o\n");
  }

  /* runtime compilation as a script. */
  /* clauses files compilation */
  if (reasoner->total_clauses > CLAUSES_NUM_BREAK) {
    for (unsigned int i=0; i<cl_files->size (); i++) {
      if (i == 0) {
	if (! koa_code_opti) {
	  if (koa_code_debug)
	    strcpy (commande,  CCEXERTDEB);
	  else strcpy (commande, CCEXERT);
	}
	else strcpy (commande, CCEXERTOPT);
      }
      else {
	if (! koa_code_opti) {
	  if (koa_code_debug)
	    strcat (commande, CCEXERTDEB);
	  else strcat (commande, CCEXERT);
	}
	else strcat (commande, CCEXERTOPT);
      }
      strcat (commande, ceIncDir);
      strcat (commande, " -I");
      strcat (commande, sysDir);
      strcat (commande, " -I");
      strcat (commande, itmsDir);
      strcat (commande, " -I");
      strcat (commande, behDir);
      strcat (commande, " -c ");
      strcat (commande, (*cl_files)[i].c_str ());
      strcat (commande, ".cpp -o ");
      strcat (commande, (*cl_files)[i].c_str ());
      strcat (commande, ".o\n\n");
    }
    if (! koa_code_opti) {
      if (koa_code_debug)
	strcat (commande, CCEXERTDEB);
      else strcat (commande, CCEXERT);
    }
    else strcat (commande, CCEXERTOPT);
  }
  else {
    if (! koa_code_opti) {
      if (koa_code_debug)
	strcpy (commande, CCEXERTDEB);
      else strcpy (commande, CCEXERT);
    }
    else strcpy (commande, CCEXERTOPT);
  }
  /* runtime compilation */
  strcat (commande, ceIncDir);
  strcat (commande, " -I");
  strcat (commande, sysDir);
  strcat (commande, " -I");
  strcat (commande, itmsDir);
  strcat (commande, " -I");
  strcat (commande, behDir);
  strcat (commande, " -c ");
  strcat (commande, runTFile);
  strcat (commande, " -o runtime/");
  strcat (commande, appliName);
  strcat (commande, "_rt.o\n\n");
  
  if (! koa_code_opti) {
    if (koa_code_debug)
      strcat (commande, CCEXEDEB);
    else strcat (commande, CCEXE);
  }
  else strcat (commande, CCEXEOPT);
  strcat (commande, ceIncDir);
  strcat (commande, " -I");
  strcat (commande, behDir);
  strcat (commande, " -I");
  strcat (commande, sysDir);
  strcat (commande, " -I");
  strcat (commande, itmsDir);
  strcat (commande, " -I/usr/local/include");
  strcat (commande, " -L");
  strcat (commande, ceLibDir);
  strcat (commande, " -L/usr/local/lib");
  strcat (commande, " -L.");
  strcat (commande, " -o ");
  strcat (commande, exeFile);
  strcat (commande, " runtime/");
  strcat (commande, appliName);
  strcat (commande, "_rt.o ");
  
  if (reasoner->total_clauses > CLAUSES_NUM_BREAK) {
    for (unsigned int i=0; i<cl_files->size (); i++) {
      strcat (commande, (*cl_files)[i].c_str ());
      strcat (commande, ".o ");
    }
  }
  strcat (commande, " -l");
  strcat (commande, appliName);
  strcat (commande, CCEXEFIN);
 
  runBuild = fopen (runBuildFile, "w");
  fprintf (runBuild, "#!/bin/csh\n%s\n", commande);
  fclose (runBuild);
  (void) chmod (runBuildFile,       /* execution rights */
		S_IRWXU |  S_IRGRP | S_IROTH);
  if (! loadError) {
    compiled = 1;
    fprintf (stdout, "Application \"%s\" compiled.\n", appliName);
    executed = 0;
  }
  else {
    compiled = 0;
    fprintf (stdout, "Unable to compile \"%s\"\n", fileIn);
  }
  
  delete generated_types;
  
  return 0;
}

/* 3. koala-generate ---------------------------------------------------*/
long koaGenerateDef (char* s, Comp* co) {

  strcpy (defDir, appliPath);
  strcat (defDir, "C");
  strcpy (defHFile, defDir);
  strcat (defHFile, "/");
  strcat (defHFile, co->type.c_str());
  strcat (defHFile, ".h");
  strcpy (defCPPFile, defDir);
  strcat (defCPPFile, "/");
  strcat (defCPPFile, co->type.c_str());
  strcat (defCPPFile, ".cpp");

  if (! inVector (co->type, generated_types)) {
    if ((defH = fopen (defHFile, "w")) == NULL)
      {
	std::cout << "[Error]:Can't create component header file: " 
		  << defHFile << ". Exiting.\n";
	exit (-1);
      }
    if ((defCPP = fopen (defCPPFile, "w")) == NULL)
      {
	std::cout << "[Error]:Can't create component body file: "
		  << defCPPFile << ". Exiting.\n";
	exit (-1);
      }
    geneClassHeaders (co->type.c_str());
  }
  else {
    defH = fopen (defHFile, "a");
    defCPP = fopen (defCPPFile, "a");
  }
  
  geneComp (co);
	  
  fclose (defH);
  fclose (defCPP);
  return 0;
}

long koaGenerateRunT () {

  string codeH, codeC, dispstr, meastr, inpstr, untempstr, tempstr, influstr,
     numi, numputs, numdisps, numeas, numutemps, numtemps, numflus;
  int dics, puts, disps, meas, utemps, temps, flus, i;

  /* cross-reference code */
  if (cross_ref != "") {
    fprintf (runT, "/* cross-reference code */\n\t");
    fprintf (runT, cross_ref.c_str ());
  }
  
  fprintf (runH, "\n\tvariable* dico;\n");
  fprintf (runT, "\n\tdico = (variable*) new_malloc (%ld*sizeof (variable));\n\t", numVarG);
  
  codeC = dispstr = meastr = inpstr = untempstr = tempstr = influstr = "";
  dics = puts = disps = meas = utemps = temps = flus = 0;

  for (hash_map<const char*, Comp*, hash<const char*>, eqstr>::iterator comps_it
	 = reasoner->active_comps->begin(); 
       comps_it != reasoner->active_comps->end(); comps_it++) {
    
    for (unsigned int i=0; i<(*comps_it).second->variables->size(); i++) {
      std::ostrstream os;
      os << dics; numi = string(os.str(), os.tellp());
      codeC += "dico[" + numi + "] = " + (*comps_it).second->var_name + "->" 
	+ string(getVarSymbName((*(*comps_it).second->variables)[i])) + ";\n\t";
      dics++;
      
      if (isVarInput ((*(*comps_it).second->variables)[i])) {
	std::ostrstream os2;
	os2 << puts; numputs = string(os2.str(), os2.tellp());
	inpstr += "input[" + numputs + "] = " + (*comps_it).second->var_name + "->" 
	  + string(getVarSymbName((*(*comps_it).second->variables)[i])) + ";\n\t";
	puts++;
      }

      if (isVarMeasure ((*(*comps_it).second->variables)[i])) {
	std::ostrstream os3;
	os3 << meas; numeas = string(os3.str(), os3.tellp());
	meastr += "measure[" + numeas + "] = " + (*comps_it).second->var_name + "->" 
	  + string(getVarSymbName((*(*comps_it).second->variables)[i])) + ";\n\t";
	meas++;
      }

      if (isVarDisplay ((*(*comps_it).second->variables)[i])) {
	std::ostrstream os4;
	os4 << disps; numdisps = string(os4.str(), os4.tellp());
	dispstr += "display[" + numdisps + "] = " + (*comps_it).second->var_name + "->" 
	  + string (getVarSymbName((*(*comps_it).second->variables)[i])) + ";\n\t";
	disps++;
      }
      
    }  /* end variables */
    
    for (unsigned int j=0; j<(*comps_it).second->influences->size(); j++) {
      std::ostrstream os5;
      os5 << flus; numflus = string(os5.str(), os5.tellp());
      influstr += "influ[" + numflus + "] = " + (*comps_it).second->var_name + "->i_"
	+ string (getInfluSymbName((*(*comps_it).second->influences)[j])) + ";\n\t";
      flus++;
    } /* end influences */
    
  } /* end components */

  listcaenVar lvt = temporalListcaen;
  int pos = 0;
  while (! isNull (lvt)) {
    variable vi = getLVVar (lvt);
    string nv = getVarNom (vi);
    pos = nv.find (".");
    nv = nv.substr (0, pos) + "->" + nv.substr (pos+1, nv.length ());
    std::ostrstream os6;
    os6 << temps; numtemps = string (os6.str(), os6.tellp());
    tempstr += "temporal[" + numtemps + "] = " + nv + ";\n\t";
    temps++;
    lvt = getLVNext (lvt);
  }
  
  listcaenVar lvu = untemporalListcaen;
  while (! isNull (lvu)) {
    variable vi = getLVVar (lvu);
    string nv = getVarNom (vi);
    pos = nv.find (".");
    nv = nv.substr (0, pos) + "->" + nv.substr (pos+1, nv.length ());
    std::ostrstream os7;
    os7 << utemps; numutemps = string (os7.str(), os7.tellp());
    untempstr += "untemporal[" + numutemps + "] = " + nv + ";\n\t";
    utemps++;
    lvu = getLVNext (lvu);
  }
  
  fprintf (runT, codeC.c_str());

  /* inputs */
  if ((numInput = listcaenVarLn (inputListcaen))) {
    fprintf (runH, "variable* input;\n");
    fprintf (runT, "\n\tinput = (variable*) new_malloc (%ld*sizeof (variable));\n\t", numInput);
    fprintf (runT, inpstr.c_str());
    fprintf (runH, "double* inval;\n");
    fprintf (runT, "inval = NULL;\n\t");
  }
  
  /* display */
  if ((numDisplay = listcaenVarLn (displayListcaen))) {
    fprintf (runH, "variable* display;\n");
    fprintf (runT, "\n\tdisplay = (variable*) new_malloc (%ld*sizeof (variable));\n\t", numDisplay);
    fprintf (runT, dispstr.c_str());
    fprintf (runH, "double* dinfval;\ndouble* dsupval;\n");
    fprintf (runT, "dinfval = (double*) new_malloc (%ld*sizeof(double));\n\tdsupval = (double*) new_malloc (%ld*sizeof(double));\n\t", numDisplay, numDisplay);
  }
  
  /* measures */
  if ((numMeasure = listcaenVarLn (measureListcaen))) {
    fprintf (runH, "variable* measure;\n\t");
    fprintf (runT, "\n\tmeasure = (variable*) new_malloc (%ld*sizeof (variable));\n\t", numMeasure);
    fprintf (runT, meastr.c_str());
    fprintf (runH, "double* mesval;\
\nlong* lowalarm;long* highalarm;\
\nlong* meslowmisb;\nlong* meshighmisb;\
\nlong* mesmisb;\n");
    fprintf (runT, "mesval = NULL;\
\n\tlowalarm = (long*) new_malloc(%ld*sizeof (long));\
\n\thighalarm = (long*) new_malloc(%ld*sizeof (long));\
\n\tmeslowmisb = (long*) new_malloc(%ld*sizeof (long));\
\n\tmeshighmisb = (long*) new_malloc(%ld*sizeof (long));\
\n\tmesmisb = (long*) new_malloc(%ld*sizeof (long));\n\t", 
	     numMeasure,numMeasure, numMeasure, numMeasure, numMeasure);
  }
  
  /* temporal */
  if ((numTemporal = listcaenVarLn (temporalListcaen))) {
    fprintf (runH, "variable* temporal;\n\t");
    fprintf (runT, "temporal = (variable*) new_malloc (%ld*sizeof (variable));\n\t", numTemporal);
    fprintf (runT, tempstr.c_str());
  }
  
  /* untemporal */
  if ((numUntemporal = listcaenVarLn (untemporalListcaen))) {
    fprintf (runH, "variable* untemporal;\n\t");
    fprintf (runT, "untemporal = (variable*) new_malloc (%ld*sizeof (variable));\n\t", numUntemporal);
    fprintf (runT, untempstr.c_str());
  }

  /* influences array */
  if (listcaenInflLn (influListcaen)) {
    fprintf (runH, "influence* influ;\n\t");
    fprintf (runT, "\n\tinflu = (influence*) new_malloc (%ld*sizeof (influence));\n\t", numInfluG);
    fprintf (runT, influstr.c_str());
    fprintf (runH, "long* condin;\n\tlong* condout;\n\t");
    fprintf (runT, "condin = (long*) new_malloc (%ld*sizeof (long));\n\tcondout = (long*) new_malloc (%ld*sizeof (long));\n\t", numInfluG, numInfluG);
  }

  /* conditions array */
  if (numConditions) {
    fprintf (runH, "condition* condi;\n\t");
    fprintf (runT, "condi = (condition*) new_malloc (%ld*sizeof (condition));\n\t", numConditions);
    fprintf (runT, condstr.c_str());
  }

  /* causal graphs array. */
  if (numNoeudG) {
    fprintf (runH, "cGraph* cG;\n\t");
    fprintf (runT, "cG = (cGraph*) new_malloc (%ld*sizeof (cGraph));\n\t", numNoeudG);
    fprintf (runT, nodestr.c_str());
  }
  
  /* initialisation array. */
  if (listcaenInitVarLn (initListcaen)) {
    fprintf (runH, "initVar* init;\n\t");
    fprintf (runT, "init = (initVar*) new_malloc (%ld*sizeof (initVar));\n\t", numInit);
    fprintf (runT, initstr.c_str());
  }
  
  if (listcaenGVarLn (gVarListcaen)) {
    fprintf (runH, "gVar* gV;\n\t");
    fprintf (runT, "gV = (gVar*) new_malloc (%ld*sizeof (gVar));\n\t", numGVarSV);
    fprintf (runT, gvarstr.c_str());
  }    

  if (listcaenExprLn (condCListcaen)) {
    fprintf (runH, "expr* aC;\n\tlong inAc;\n\t");
    fprintf (runT, "aC = (expr*) new_malloc (%ld*sizeof (expr));\n\t", numCondC);
    fprintf (runT, condcstr.c_str());
    fprintf (runT, "long* vals = (long*) new_malloc (%ld*sizeof (long));\n\t", numCondC);
    for (i=1; i<numCondC; ++i)
      fprintf (runT, "vals[%i] = 0;\n\t", i);
    fprintf (runT, "long* inAc = (long*) new_malloc (%ld*sizeof (long));\n\t", numCondC);
    for (i=0; i<numCondC; ++i)
      fprintf (runT, "inAc[%i] = 0;\n\t", i);
  }

  /* mapping function expressions */
  if (numMFExpr) {
    fprintf (runH, "expr* aMF;\n\t");
    fprintf (runT, "expr* aMF = (expr*) new_malloc (%ld*sizeof (expr));\n\t", numMFExpr);
    fprintf (runT, mfexprstr.c_str ());
  }

  if (listcaenExprLn (globCListcaen)) {
    fprintf (runH, "expr* aG;\n\tlong inAg;\n\t");
    fprintf (runT, "expr* aG = (expr*) new_malloc (%ld*sizeof (expr));\n\t", numGlobC);
    fprintf (runT, globstr.c_str());
    fprintf (runT, "long* inAg = (long*) new_malloc (%ld*sizeof (long));\n\t", numGlobC);
    for (i=0; i<numGlobC; ++i)
      fprintf (runT, "inAg[%i] = 0;\n\t", i);
  } /* endif listcaencaenGVarLn */
 
  fprintf (runH, "runtime %s_rt;\n", appliName);
  fprintf (runH, "runtime koala_rt;\n");
  fprintf (runT, "%s_rt = (runtime) new_malloc (sizeof (s_runtime));\n\t", appliName);
  fprintf (runT, "%s_rt->appli = \"%s\";\n\t%s_rt->num = 0;\n\t%s_rt->ts = %g;\n\t%s_rt->dts = 0;\n\t%s_rt->twc = %ld;\n\t%s_rt->nvar = %ld;\n\t%s_rt->dico = dico;\n\t", appliName, appliName, appliName, appliName, timeStep, appliName, appliName, twc, appliName, numVarG, appliName);

  if (numInput)
    fprintf (runT, "%s_rt->nin = %ld;\n\t%s_rt->in = input;\n\t%s_rt->inval = inval;\n\t", appliName, numInput, appliName, appliName);
  else
    fprintf (runT, "%s_rt->nin = 0;\n\t%s_rt->in = NULL;\n\t%s_rt->inval = NULL;\n\t", appliName, appliName, appliName);
  if (numDisplay)
    fprintf (runT, "%s_rt->ndisp = %ld;\n\t%s_rt->disp = display;\n\t%s_rt->dispinfval = dinfval;\n\t%s_rt->dispsupval = dsupval;\n\t%s_rt->ndispall = 0;\n\t%s_rt->dispall = NULL;\n\t", appliName, numDisplay, appliName, appliName, appliName, appliName, appliName);
  else
     fprintf (runT, "%s_rt->ndisp = 0;\n\t%s_rt->disp = NULL;\n\t%s_rt->dispinfval = NULL;\n\t%s_rt->dispsupval = NULL;\n\t%s_rt->ndispall = 0;\n\t%s_rt->dispall = NULL;\n\t", appliName, appliName, appliName, appliName, appliName, appliName);
  if (numMeasure)
    fprintf (runT, "%s_rt->nmes = %ld;\n\t%s_rt->mes = measure;\n\t%s_rt->mesval = mesval;\n\t%s_rt->lowalarm = lowalarm;\n\t%s_rt->highalarm = highalarm;\n\t%s_rt->lowmisb = meslowmisb;\n\t%s_rt->highmisb = meshighmisb;\n\t%s_rt->misb = mesmisb;\n\t", appliName, numMeasure, appliName, appliName, appliName, appliName, appliName, appliName, appliName);
  else
    fprintf (runT, "%s_rt->nmes = 0;\n\t%s_rt->mes = NULL;\n\t%s_rt->mesval = NULL;\n\t%s_rt->lowalarm = NULL;\n\t%s_rt->highalarm = NULL;\n\t%s_rt->lowmisb = NULL;\n\t%s_rt->highmisb = NULL;\n\t%s_rt->misb = NULL;\n\t", appliName, appliName, appliName, appliName, appliName, appliName, appliName, appliName);
  if (numTemporal)
    fprintf (runT, "%s_rt->ntemp = %ld;\n\t%s_rt->temp = temporal;\n\t", appliName, numTemporal, appliName);
  else
    fprintf (runT, "%s_rt->ntemp = 0;\n\t%s_rt->temp = NULL;\n\t", appliName, appliName);
  if (numUntemporal)
    fprintf (runT, "%s_rt->nuntemp = %ld;\n\t%s_rt->untemp = untemporal;\n\t", appliName, numUntemporal, appliName);
  else
    fprintf (runT, "%s_rt->nuntemp = 0;\n\t%s_rt->untemp = NULL;\n\t", appliName, appliName);
  if (numInfluG)
    fprintf (runT, "%s_rt->nifl = %ld;\n\t%s_rt->infl = influ;\n\t%s_rt->condin = condin;\n\t%s_rt->condout = condout;\n\t", appliName, numInfluG, appliName, appliName, appliName);
  else
    fprintf (runT, "%s_rt->nifl = 0;\n\t%s_rt->infl = NULL;\n\t%s_rt->condin = NULL;\n\t%s_rt->condout = NULL;\n\t", appliName, appliName, appliName, appliName);
  if (numNoeudG)
    fprintf (runT, "%s_rt->ncg = %ld;\n\t%s_rt->cg = cG;\n\t", appliName, numNoeudG, appliName);
  else
     fprintf (runT, "%s_rt->ncg = 0;\n\t%s_rt->cg = NULL;\n\t", appliName, appliName);
  fprintf (runT, "%s_rt->maxDepth = %ld;\n\t", appliName, maxDepth);
  if (numInit)
    fprintf (runT, "%s_rt->nit = %ld;\n\t%s_rt->iv = init;\n\t", appliName, numInit, appliName);
  else
    fprintf (runT, "%s_rt->nit = 0;\n\t%s_rt->iv = NULL;\n\t", appliName, appliName);
  if (numGVarSV)
    fprintf (runT, "%s_rt->ngv = %ld;\n\t%s_rt->vgv = gV;\n\t", appliName, numGVarSV, appliName);
  else
    fprintf (runT, "%s_rt->ngv = 0;\n\t%s_rt->vgv = NULL;\n\t", appliName, appliName);
  if (numGlobC)
    fprintf (runT, "%s_rt->ngc = %ld;\n\t%s_rt->glc = aG;\n\t%s_rt->inag = inAg;\n\t", appliName, numGlobC, appliName, appliName);
  else
    fprintf (runT, "%s_rt->ngc = 0;\n\t%s_rt->glc = NULL;\n\t%s_rt->inag = NULL;\n\t", appliName, appliName, appliName);
  if (numCondC)
    fprintf (runT, "%s_rt->ncdc = %ld;\n\t%s_rt->cdc = aC;\n\t%s_rt->valSpc = vals;\n\t%s_rt->inac = inAc;\n\t", appliName, numCondC, appliName, appliName, appliName);
  else
    fprintf (runT, "%s_rt->ncdc = 0;\n\t%s_rt->cdc = NULL;\n\t%s_rt->valSpc = NULL;\n\t%s_rt->inac = NULL;\n\t", appliName, appliName, appliName, appliName);
  if (numMFExpr)
    fprintf (runT, "%s_rt->nmfc = %ld;\n\t%s_rt->mfc = aMF;\n\t", appliName, numMFExpr, appliName);
  else fprintf (runT, "%s_rt->mfc = 0;\n\t%s_rt->mfc = NULL;\n\t", appliName, appliName);
  fprintf (runT, "%s_rt->inited = 0;\n\t%s_rt->runGC = 0;\n\t%s_rt->cumTime = 0;\n\t%s_rt->prec = 0;\n\t%s_rt->onlyFaultIso = 0;\n\t%s_rt->numMisb = 0;\n\t%s_rt->numOk = 0;\n\t%s_rt->mbVA = NULL;\n\t%s_rt->okVA = NULL;\n\t%s_rt->sfVA = NULL;\n\t%s_rt->oldNumMisb = 0;\n\t%s_rt->oldMisbVarArray = NULL;\n\t%s_rt->numNodesHST = 0;%s_rt->ncondi = %ld;\n\t%s_rt->condi = condi;\n\t", appliName, appliName, appliName, appliName, appliName, appliName, appliName, appliName, appliName, appliName, appliName, appliName, appliName, appliName, numConditions, appliName);
  fprintf (runT, "%s_rt->bridgeEvents = NULL;\n\t%s_rt->bridgeConds = NULL;\n\t%s_rt->bridgeTransitions = NULL;%s_rt->bridgeConflicts = NULL;\n\t", appliName, appliName, appliName, appliName);
  fprintf (runT, "createLeafListcaen (&%s_rt->HSTree);\n\tcreateConflictSet (&%s_rt->softConflictListcaen);\n\t%s_rt->diagOut = NULL;\n\t", appliName, appliName, appliName);
  fprintf (runT, "\n/* remove next line if linking several applications \
		       together */\nkoala_rt=%s_rt;\n\t}", appliName);

  /* add runtime flags and stuff */
#ifdef ENV_OPTI
  if (koa_evlps_opti)   /* envelopes optimization */
    fprintf (runT, "\nbool env_opti = 1;\n");
  else fprintf (runT, "\nbool env_opti = 0;\n");
#endif

  fprintf (runT, "long guards_int = %ld;\n\t", guards_int);
  fprintf (runT, "int Trajectory::twd = %ld;\n\t", twd);
  fprintf (runT, "long h_pi = %ld;\n\t", pi);
  fprintf (runT, "string model_name = \"%s\";\n\t", appliName);

  fclose (runT);
  fclose (runH);

  return 0;
}

/* 4. caen-execute ----------------------------------------------------*/

long ceExec (char *s) {
  int status;
  long ok, ipar=0;
  char *t;

  if (! loaded) {
    fprintf (stdout, "Please load application first !\n");
    return 0;
  }
  if (! compiled) {
    fprintf (stdout, "Please compile application first !\n");
    return 0;
  }
  strcpy (param1, "");
  strcpy (param2, "");
  strcpy (param3, "");
  strcpy (param4, "");
  t = strtok (s, " ");
  if (numInput) {
    if (isNull (t)) {                           /* t: first parameter */
      fprintf (stdout, "Not enough parameters (expecting input file) !\n");
      return 0;
    }
    else { /* isNull 1st parameter */
      stripWhite (t);
      strcpy (param[ipar++], t);
      t = strtok (NULL, " ");
    } /* endif isNull 1st parameter */
  } /* endif  numInput */
  if (numMeasure) {
    if (isNull (t)) {                           /* t: second parameter */
      fprintf (stdout, "Not enough parameters (expecting measure file) !\n");
      return 0;
    }
    else { /* isNull 2nd parameter */
      stripWhite (t);
      strcpy (param[ipar++], t);
      t = strtok (NULL, " ");
    } /* endif isNull 2nd parameter */
  } /* endif numMeasure */
  if (numDisplay) {
    if (! isNull (t)) {                          /* t: third parameter */
      stripWhite (t);
      strcpy (param[ipar++], t);
      t = strtok (NULL, " ");
    } /* endif ! isNull 3rd parameter */
  } /* endif numDisplay */
  if (! isNull (t)) {
    stripWhite (t);
    strcpy (param[ipar++], t);
  }

  fprintf (stdout, "Compiling runtime\n");

  /* clauses files compilation */
  if (reasoner->total_clauses > CLAUSES_NUM_BREAK) {
    for (unsigned int i=0; i<cl_files->size (); i++) {
      if (! koa_code_opti) {
	if (koa_code_debug)
	  strcpy (commande,  CCEXERTDEB);
	else strcpy (commande, CCEXERT);
      }
      else strcpy (commande, CCEXERTOPT);
      strcat (commande, ceIncDir);
      strcat (commande, " -I");
      strcat (commande, sysDir);
      strcat (commande, " -I");
      strcat (commande, itmsDir);
      strcat (commande, " -I");
      strcat (commande, behDir);
      strcat (commande, " -c ");
      strcat (commande, (*cl_files)[i].c_str ());
      strcat (commande, ".cpp -o ");
      strcat (commande, (*cl_files)[i].c_str ());
      strcat (commande, ".o");
      cout << commande << endl;
      if (0 != system (commande)) {
	fprintf (stdout, "... clause file compilation failed.\n");
	return 0;
      }
    }
  }
  
  if (! koa_code_opti) {
    if (koa_code_debug)
      strcpy (commande, CCEXERTDEB);
    else strcpy (commande, CCEXERT);
  }
  else strcpy (commande, CCEXERTOPT);
  strcat (commande, ceIncDir);
  strcat (commande, " -I");
  strcat (commande, sysDir);
  strcat (commande, " -I");
  strcat (commande, itmsDir);
  strcat (commande, " -I");
  strcat (commande, behDir);
  strcat (commande, " -c ");
  strcat (commande, runTFile);
  strcat (commande, " -o runtime/");
  strcat (commande, appliName);
  strcat (commande, "_rt.o");

  cout << commande << endl;
  if (0 != system (commande)) {
    fprintf (stdout, "... runtime compilation failed.\n");
    return 0;
  }
  else fprintf (stdout, "runtime compilation successful.\n");

  fprintf (stdout, "C-linking\n");
  strcpy (commande, CCEXEDEB);
  strcat (commande, ceIncDir);
  strcat (commande, " -I");
  strcat (commande, sysDir);
  strcat (commande, " -I");
  strcat (commande, itmsDir);
  strcat (commande, " -I");
  strcat (commande, behDir);
  strcat (commande, " -I/usr/local/include");
  strcat (commande, " -L");
  strcat (commande, ceLibDir);
  strcat (commande, " -L/usr/local/lib");
  strcat (commande, " -L.");
  strcat (commande, " -o ");
  strcat (commande, exeFile);
  strcat (commande, " runtime/");
  strcat (commande, appliName);
  strcat (commande, "_rt.o ");
  
  if (reasoner->total_clauses > CLAUSES_NUM_BREAK) {
    for (unsigned int i=0; i<cl_files->size (); i++) {
      strcat (commande, (*cl_files)[i].c_str ());
      strcat (commande, ".o ");
    }
  }
  strcat (commande, " -l");
  strcat (commande, appliName);
  strcat (commande, " ");
  strcat (commande, CCEXEFIN);
  fprintf (stdout, commande);
  timeInit ();
  if (0 != system(commande)) {                                   /* SunOs4 */
    fprintf (stdout, "... failed.\n");
    return 0;
  }
  else { /* system */
    /*#ifdef DEBUG*/
    fprintf (stdout, "            ... done. C-link time: %.2f s.\n", spentTime ());
    /*#else*/ /* DEBUG */
    /*fprintf (stdout, "... done.\n");
      #endif*/ /* DEBUG */
    delete cl_files; 
  }
  fflush (NULL);
  if (fork () == 0) {
    switch (ipar) {
    case 0:
      execl (exeFile, exeName, NULL);
      break;
    case 1:
      execl (exeFile, exeName, param1, NULL);
      break;
    case 2:
      execl (exeFile, exeName, param1, param2, NULL);
      break;
    case 3:
      execl (exeFile, exeName, param1, param2, param3, NULL);
      break;
    case 4:
      execl (exeFile, exeName, param1, param2, param3, param4, NULL);
    default:
      break;
    } /* end switch */
  } /* endif fork */
  wait (&status);
  ok = WEXITSTATUS (status);                 /* cf <sys/wait.h> (non ansi)   */
#ifdef DEBUG
  fprintf (stdout, "Ce-exec status: %ld\n", ok);
#endif /* DEBUG */
  if (ok!=0)
    done = 1;
  else
    executed = 1;
  return ok;
}


/* 5. koala-print ------------------------------------------------------*/

long cePrint (char *s) {

  char* argu;
  
  if (! loaded) {
    fprintf (stdout, "Please load application first !\n");
    return 0;
  }
  if (isNull (s)) {
    fprintf (stdout, "Missing argument for print.\n");
    return 0;
  }
  if (! isNull (strstr (s, "dic"))) {
    printDic ();
    return 0;
  }
  if (! isNull (strstr (s, "inf"))) {
    printRules ();
    return 0;
  }
  if (!isNull (strstr (s, "cond"))) {
    printConditions ();
    return 0;
  }
  if (!isNull (argu = strstr (s, "co"))) {
    s = strtok (argu, " ");
    s = strtok(NULL, " ");
    if (isNull (s))
      printComps ();
    else
      printComp (s);
    return 0;
  }
  if (! isNull (strstr (s, "toms"))) {
    if (! compiled) {
      fprintf (stdout, "Please compile application first !\n");
      return 0;
    }
    fprintf (stdout, "Boolean propositions:\n");
    printAtoms ();
    return 0;
  }
  if (! isNull (strstr (s, "gra"))) {
    if (! compiled) {
      fprintf (stdout, "Please compile application first !\n");
      return 0;
    }
    fprintf (stdout, "Causal graph:\n");
    printCGraph (dictionary);
    return 0;
  }
  if (! isNull (strstr (s, "upd"))) {
    if (! compiled) {
      fprintf (stdout, "Please compile application first !\n");
      return 0;
    }
    fprintf (stdout, "Updating sequence:");
    if (! isNull (temporalListcaen)) {
      fprintf (stdout, "\n Temporal listcaen: ");
      printUpdateListcaen (stdout, temporalListcaen);
    }
    if (! isNull (untemporalListcaen)) {
      fprintf (stdout, "\n Untemporal listcaen: ");
      printUpdateListcaen (stdout, untemporalListcaen);
    }
    fprintf (stdout, "\n");
    return 0;
  }
  if (! isNull (strstr (s, "glo"))) {
    printGlobCs ();
    return 0;
  }
  if (! isNull (strstr (s, "cdc"))) {
    printCondCs ();
    return 0;
  }
  if (! isNull (strstr (s, "ini"))) {
    if (isNull (initListcaen))
      fprintf (stdout, "No initializations.\n");
    else {
      fprintf (stdout, "Initializations:\n");
      printInitListcaen (stdout, initListcaen);
    }
    return 0;
  }
  if (! isNull (strstr (s, "allvar"))) {
    printAllVars ();
    return 0;
  }
  fprintf (stdout, "Can't print %s\n", s);
  return 0;
}

#ifdef HAVE_DOT
/* koala-graph  ------------------------------------------------------*/
long ceGraph (char *s) {   /* files are in fig/ */

  if (! isNull (strstr (s, "cg"))) {           /* causal graph */
    if (! compiled) {
      fprintf (stdout, "Please compile application first !\n");
      return 0;
    }
    string fn = string (figDir) + string (appliName) + ".dot";
    FILE* fdcg = fopen (fn.c_str (), "w");
    geneDotHeaders (fdcg);
    dotCGraph (dictionary, fdcg);
    fprintf (fdcg, "}");
    fclose (fdcg);
    launchPs (appliName);
    return 0;
  }
  char* argu;
  if (! isNull (argu = strtok (s, " "))) {                          /* a component */
    graphComp (argu);
  }

  return 0;
}
#endif /* HAVE_DOT */

/* 9. koala-reload ---------------------------------------------------*/

long ceReload (char *s) {

  fflush (NULL);
  execl (cePath, KOALANAME, fileIn, NULL);
  return 1;
}

/* 10. koala-unload ---------------------------------------------------*/

long ceUnload (char *s) {

  if (loaded) {
    fprintf (stdout, "Application \"%s\" unloaded.\n", appliName);
    fflush (NULL);
    execl (cePath, KOALANAME, "new", NULL);       /* empieza un nuevo caen */
  }
  else
    fprintf (stdout, "No application to unload.\n");
  return 1;
}

/* basuras -----------------------------------------------------------*/

/*------------------------------------------------------------------*/

