#include "tanks_rt.h"

using namespace std;

void startinit (Scheduler* sMM) {

	VC = new valve_cont("vc", 0, 0, T2);
	VC->type = "valve_cont";
	VC->var_name = "VC";
	V2 = new valve_down("v2", VC->cmd_out, 0, T1, T2);
	V2->type = "valve_down";
	V2->var_name = "V2";
	V1 = new valve_up("v1", VC->cmd_out, 0, T1, T2);
	V1->type = "valve_up";
	V1->var_name = "V1";
	T1 = new tank1("t1", VC->cmd_out, 0, P1, V1, V2);
	T1->type = "tank1";
	T1->var_name = "T1";
	P1 = new pump("p1", 0, 0, T1);
	P1->type = "pump";
	P1->var_name = "P1";
	T2 = new tank2("t2", 0, 0, V1, V2);
	T2->type = "tank2";
	T2->var_name = "T2";
	sMM->addComp(P1);
	sMM->addComp(T1);
	sMM->addComp(T2);
	sMM->addComp(VC);
	sMM->addComp(V1);
	sMM->addComp(V2);

	Clause* cl1 = new Clause (P1);
	cl1->addAtomRef(P1->pump_mode_failed, true);
	cl1->addAtomRef(P1->pump_mode_ok, true);
	cl1->setInternal(1);
	P1->pump_mode->internal_clauses->push_back(cl1);
sMM->cls->push_back (cl1);
	
	Clause* cl2 = new Clause (P1);
	cl2->addAtomRef(P1->pump_mode_unknown, true);
	cl2->addAtomRef(P1->pump_mode_ok, true);
	cl2->setInternal(1);
	P1->pump_mode->internal_clauses->push_back(cl2);
sMM->cls->push_back (cl2);
	
	Clause* cl3 = new Clause (P1);
	cl3->addAtomRef(P1->pump_mode_unknown, true);
	cl3->addAtomRef(P1->pump_mode_failed, true);
	cl3->setInternal(1);
	P1->pump_mode->internal_clauses->push_back(cl3);
sMM->cls->push_back (cl3);
	
	Clause* cl4 = new Clause (P1);
	cl4->addAtomRef(P1->pump_mode_unknown, false);
	cl4->addAtomRef(P1->pump_mode_failed, false);
	cl4->addAtomRef(P1->pump_mode_ok, false);
	cl4->setInternal(1);
	P1->pump_mode->internal_clauses->push_back(cl4);
sMM->cls->push_back (cl4);
	
	Clause* cl5 = new Clause (T1);
	cl5->addAtomRef(T1->tank1_c1_c10, true);
	cl5->addAtomRef(T1->tank1_c1_c11, true);
	cl5->setInternal(1);
	T1->tank1_c1->internal_clauses->push_back(cl5);
sMM->cls->push_back (cl5);
	
	Clause* cl6 = new Clause (T1);
	cl6->addAtomRef(T1->tank1_c1_c10, false);
	cl6->addAtomRef(T1->tank1_c1_c11, false);
	cl6->setInternal(1);
	T1->tank1_c1->internal_clauses->push_back(cl6);
sMM->cls->push_back (cl6);
	
	Clause* cl7 = new Clause (T1);
	cl7->addAtomRef(T1->tank1_mode_leak, true);
	cl7->addAtomRef(T1->tank1_mode_ok, true);
	cl7->setInternal(1);
	T1->tank1_mode->internal_clauses->push_back(cl7);
sMM->cls->push_back (cl7);
	
	Clause* cl8 = new Clause (T1);
	cl8->addAtomRef(T1->tank1_mode_unknown, true);
	cl8->addAtomRef(T1->tank1_mode_ok, true);
	cl8->setInternal(1);
	T1->tank1_mode->internal_clauses->push_back(cl8);
sMM->cls->push_back (cl8);
	
	Clause* cl9 = new Clause (T1);
	cl9->addAtomRef(T1->tank1_mode_unknown, true);
	cl9->addAtomRef(T1->tank1_mode_leak, true);
	cl9->setInternal(1);
	T1->tank1_mode->internal_clauses->push_back(cl9);
sMM->cls->push_back (cl9);
	
	Clause* cl10 = new Clause (T1);
	cl10->addAtomRef(T1->tank1_mode_unknown, false);
	cl10->addAtomRef(T1->tank1_mode_leak, false);
	cl10->addAtomRef(T1->tank1_mode_ok, false);
	cl10->setInternal(1);
	T1->tank1_mode->internal_clauses->push_back(cl10);
sMM->cls->push_back (cl10);
	
	Clause* cl11 = new Clause (T2);
	cl11->addAtomRef(T2->tank2_c1_c11, true);
	cl11->addAtomRef(T2->tank2_c1_c12, true);
	cl11->setInternal(1);
	T2->tank2_c1->internal_clauses->push_back(cl11);
sMM->cls->push_back (cl11);
	
	Clause* cl12 = new Clause (T2);
	cl12->addAtomRef(T2->tank2_c1_c10, true);
	cl12->addAtomRef(T2->tank2_c1_c12, true);
	cl12->setInternal(1);
	T2->tank2_c1->internal_clauses->push_back(cl12);
sMM->cls->push_back (cl12);
	
	Clause* cl13 = new Clause (T2);
	cl13->addAtomRef(T2->tank2_c1_c10, true);
	cl13->addAtomRef(T2->tank2_c1_c11, true);
	cl13->setInternal(1);
	T2->tank2_c1->internal_clauses->push_back(cl13);
sMM->cls->push_back (cl13);
	
	Clause* cl14 = new Clause (T2);
	cl14->addAtomRef(T2->tank2_c1_c10, false);
	cl14->addAtomRef(T2->tank2_c1_c11, false);
	cl14->addAtomRef(T2->tank2_c1_c12, false);
	cl14->setInternal(1);
	T2->tank2_c1->internal_clauses->push_back(cl14);
sMM->cls->push_back (cl14);
	
	Clause* cl15 = new Clause (T2);
	cl15->addAtomRef(T2->tank2_c2_c20, true);
	cl15->addAtomRef(T2->tank2_c2_c21, true);
	cl15->setInternal(1);
	T2->tank2_c2->internal_clauses->push_back(cl15);
sMM->cls->push_back (cl15);
	
	Clause* cl16 = new Clause (T2);
	cl16->addAtomRef(T2->tank2_c2_c20, false);
	cl16->addAtomRef(T2->tank2_c2_c21, false);
	cl16->setInternal(1);
	T2->tank2_c2->internal_clauses->push_back(cl16);
sMM->cls->push_back (cl16);
	
	Clause* cl17 = new Clause (T2);
	cl17->addAtomRef(T2->tank2_mode_unknown, true);
	cl17->addAtomRef(T2->tank2_mode_ok, true);
	cl17->setInternal(1);
	T2->tank2_mode->internal_clauses->push_back(cl17);
sMM->cls->push_back (cl17);
	
	Clause* cl18 = new Clause (T2);
	cl18->addAtomRef(T2->tank2_mode_unknown, false);
	cl18->addAtomRef(T2->tank2_mode_ok, false);
	cl18->setInternal(1);
	T2->tank2_mode->internal_clauses->push_back(cl18);
sMM->cls->push_back (cl18);
	
	Clause* cl19 = new Clause (V1);
	cl19->addAtomRef(V1->valve_up_c3_c30, true);
	cl19->addAtomRef(V1->valve_up_c3_c31, true);
	cl19->setInternal(1);
	V1->valve_up_c3->internal_clauses->push_back(cl19);
sMM->cls->push_back (cl19);
	
	Clause* cl20 = new Clause (V1);
	cl20->addAtomRef(V1->valve_up_c3_c30, false);
	cl20->addAtomRef(V1->valve_up_c3_c31, false);
	cl20->setInternal(1);
	V1->valve_up_c3->internal_clauses->push_back(cl20);
sMM->cls->push_back (cl20);
	
	Clause* cl21 = new Clause (V1);
	cl21->addAtomRef(V1->valve_up_mode_closed, true);
	cl21->addAtomRef(V1->valve_up_mode_open, true);
	cl21->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl21);
sMM->cls->push_back (cl21);
	
	Clause* cl22 = new Clause (V1);
	cl22->addAtomRef(V1->valve_up_mode_stuck_closed, true);
	cl22->addAtomRef(V1->valve_up_mode_open, true);
	cl22->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl22);
sMM->cls->push_back (cl22);
	
	Clause* cl23 = new Clause (V1);
	cl23->addAtomRef(V1->valve_up_mode_stuck_open, true);
	cl23->addAtomRef(V1->valve_up_mode_open, true);
	cl23->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl23);
sMM->cls->push_back (cl23);
	
	Clause* cl24 = new Clause (V1);
	cl24->addAtomRef(V1->valve_up_mode_unknown, true);
	cl24->addAtomRef(V1->valve_up_mode_open, true);
	cl24->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl24);
sMM->cls->push_back (cl24);
	
	Clause* cl25 = new Clause (V1);
	cl25->addAtomRef(V1->valve_up_mode_stuck_closed, true);
	cl25->addAtomRef(V1->valve_up_mode_closed, true);
	cl25->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl25);
sMM->cls->push_back (cl25);
	
	Clause* cl26 = new Clause (V1);
	cl26->addAtomRef(V1->valve_up_mode_stuck_open, true);
	cl26->addAtomRef(V1->valve_up_mode_closed, true);
	cl26->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl26);
sMM->cls->push_back (cl26);
	
	Clause* cl27 = new Clause (V1);
	cl27->addAtomRef(V1->valve_up_mode_unknown, true);
	cl27->addAtomRef(V1->valve_up_mode_closed, true);
	cl27->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl27);
sMM->cls->push_back (cl27);
	
	Clause* cl28 = new Clause (V1);
	cl28->addAtomRef(V1->valve_up_mode_stuck_open, true);
	cl28->addAtomRef(V1->valve_up_mode_stuck_closed, true);
	cl28->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl28);
sMM->cls->push_back (cl28);
	
	Clause* cl29 = new Clause (V1);
	cl29->addAtomRef(V1->valve_up_mode_unknown, true);
	cl29->addAtomRef(V1->valve_up_mode_stuck_closed, true);
	cl29->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl29);
sMM->cls->push_back (cl29);
	
	Clause* cl30 = new Clause (V1);
	cl30->addAtomRef(V1->valve_up_mode_unknown, true);
	cl30->addAtomRef(V1->valve_up_mode_stuck_open, true);
	cl30->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl30);
sMM->cls->push_back (cl30);
	
	Clause* cl31 = new Clause (V1);
	cl31->addAtomRef(V1->valve_up_mode_unknown, false);
	cl31->addAtomRef(V1->valve_up_mode_stuck_open, false);
	cl31->addAtomRef(V1->valve_up_mode_stuck_closed, false);
	cl31->addAtomRef(V1->valve_up_mode_closed, false);
	cl31->addAtomRef(V1->valve_up_mode_open, false);
	cl31->setInternal(1);
	V1->valve_up_mode->internal_clauses->push_back(cl31);
sMM->cls->push_back (cl31);
	
	Clause* cl32 = new Clause (V2);
	cl32->addAtomRef(V2->valve_down_c1_c10, true);
	cl32->addAtomRef(V2->valve_down_c1_c11, true);
	cl32->setInternal(1);
	V2->valve_down_c1->internal_clauses->push_back(cl32);
sMM->cls->push_back (cl32);
	
	Clause* cl33 = new Clause (V2);
	cl33->addAtomRef(V2->valve_down_c1_c10, false);
	cl33->addAtomRef(V2->valve_down_c1_c11, false);
	cl33->setInternal(1);
	V2->valve_down_c1->internal_clauses->push_back(cl33);
sMM->cls->push_back (cl33);
	
	Clause* cl34 = new Clause (V2);
	cl34->addAtomRef(V2->valve_down_mode_open, true);
	cl34->addAtomRef(V2->valve_down_mode_closed, true);
	cl34->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl34);
sMM->cls->push_back (cl34);
	
	Clause* cl35 = new Clause (V2);
	cl35->addAtomRef(V2->valve_down_mode_stuck_closed, true);
	cl35->addAtomRef(V2->valve_down_mode_closed, true);
	cl35->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl35);
sMM->cls->push_back (cl35);
	
	Clause* cl36 = new Clause (V2);
	cl36->addAtomRef(V2->valve_down_mode_stuck_open, true);
	cl36->addAtomRef(V2->valve_down_mode_closed, true);
	cl36->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl36);
sMM->cls->push_back (cl36);
	
	Clause* cl37 = new Clause (V2);
	cl37->addAtomRef(V2->valve_down_mode_unknown, true);
	cl37->addAtomRef(V2->valve_down_mode_closed, true);
	cl37->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl37);
sMM->cls->push_back (cl37);
	
	Clause* cl38 = new Clause (V2);
	cl38->addAtomRef(V2->valve_down_mode_stuck_closed, true);
	cl38->addAtomRef(V2->valve_down_mode_open, true);
	cl38->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl38);
sMM->cls->push_back (cl38);
	
	Clause* cl39 = new Clause (V2);
	cl39->addAtomRef(V2->valve_down_mode_stuck_open, true);
	cl39->addAtomRef(V2->valve_down_mode_open, true);
	cl39->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl39);
sMM->cls->push_back (cl39);
	
	Clause* cl40 = new Clause (V2);
	cl40->addAtomRef(V2->valve_down_mode_unknown, true);
	cl40->addAtomRef(V2->valve_down_mode_open, true);
	cl40->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl40);
sMM->cls->push_back (cl40);
	
	Clause* cl41 = new Clause (V2);
	cl41->addAtomRef(V2->valve_down_mode_stuck_open, true);
	cl41->addAtomRef(V2->valve_down_mode_stuck_closed, true);
	cl41->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl41);
sMM->cls->push_back (cl41);
	
	Clause* cl42 = new Clause (V2);
	cl42->addAtomRef(V2->valve_down_mode_unknown, true);
	cl42->addAtomRef(V2->valve_down_mode_stuck_closed, true);
	cl42->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl42);
sMM->cls->push_back (cl42);
	
	Clause* cl43 = new Clause (V2);
	cl43->addAtomRef(V2->valve_down_mode_unknown, true);
	cl43->addAtomRef(V2->valve_down_mode_stuck_open, true);
	cl43->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl43);
sMM->cls->push_back (cl43);
	
	Clause* cl44 = new Clause (V2);
	cl44->addAtomRef(V2->valve_down_mode_unknown, false);
	cl44->addAtomRef(V2->valve_down_mode_stuck_open, false);
	cl44->addAtomRef(V2->valve_down_mode_stuck_closed, false);
	cl44->addAtomRef(V2->valve_down_mode_open, false);
	cl44->addAtomRef(V2->valve_down_mode_closed, false);
	cl44->setInternal(1);
	V2->valve_down_mode->internal_clauses->push_back(cl44);
sMM->cls->push_back (cl44);
	
	Clause* cl45 = new Clause (VC);
	cl45->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl45->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl45->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl45);
sMM->cls->push_back (cl45);
	
	Clause* cl46 = new Clause (VC);
	cl46->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl46->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl46->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl46);
sMM->cls->push_back (cl46);
	
	Clause* cl47 = new Clause (VC);
	cl47->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl47->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl47->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl47);
sMM->cls->push_back (cl47);
	
	Clause* cl48 = new Clause (VC);
	cl48->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl48->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl48->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl48);
sMM->cls->push_back (cl48);
	
	Clause* cl49 = new Clause (VC);
	cl49->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl49->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl49->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl49);
sMM->cls->push_back (cl49);
	
	Clause* cl50 = new Clause (VC);
	cl50->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl50->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl50->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl50);
sMM->cls->push_back (cl50);
	
	Clause* cl51 = new Clause (VC);
	cl51->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl51->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl51->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl51);
sMM->cls->push_back (cl51);
	
	Clause* cl52 = new Clause (VC);
	cl52->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl52->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl52->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl52);
sMM->cls->push_back (cl52);
	
	Clause* cl53 = new Clause (VC);
	cl53->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl53->addAtomRef(VC->valve_cont_cmdin_none, true);
	cl53->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl53);
sMM->cls->push_back (cl53);
	
	Clause* cl54 = new Clause (VC);
	cl54->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl54->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl54->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl54);
sMM->cls->push_back (cl54);
	
	Clause* cl55 = new Clause (VC);
	cl55->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl55->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl55->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl55);
sMM->cls->push_back (cl55);
	
	Clause* cl56 = new Clause (VC);
	cl56->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl56->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl56->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl56);
sMM->cls->push_back (cl56);
	
	Clause* cl57 = new Clause (VC);
	cl57->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl57->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl57->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl57);
sMM->cls->push_back (cl57);
	
	Clause* cl58 = new Clause (VC);
	cl58->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl58->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl58->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl58);
sMM->cls->push_back (cl58);
	
	Clause* cl59 = new Clause (VC);
	cl59->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl59->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl59->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl59);
sMM->cls->push_back (cl59);
	
	Clause* cl60 = new Clause (VC);
	cl60->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl60->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl60->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl60);
sMM->cls->push_back (cl60);
	
	Clause* cl61 = new Clause (VC);
	cl61->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl61->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl61->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl61);
sMM->cls->push_back (cl61);
	
	Clause* cl62 = new Clause (VC);
	cl62->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl62->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl62->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl62);
sMM->cls->push_back (cl62);
	
	Clause* cl63 = new Clause (VC);
	cl63->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl63->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl63->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl63);
sMM->cls->push_back (cl63);
	
	Clause* cl64 = new Clause (VC);
	cl64->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl64->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl64->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl64);
sMM->cls->push_back (cl64);
	
	Clause* cl65 = new Clause (VC);
	cl65->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl65->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl65->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl65);
sMM->cls->push_back (cl65);
	
	Clause* cl66 = new Clause (VC);
	cl66->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl66->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl66->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl66);
sMM->cls->push_back (cl66);
	
	Clause* cl67 = new Clause (VC);
	cl67->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl67->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl67->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl67);
sMM->cls->push_back (cl67);
	
	Clause* cl68 = new Clause (VC);
	cl68->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl68->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl68->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl68);
sMM->cls->push_back (cl68);
	
	Clause* cl69 = new Clause (VC);
	cl69->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl69->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl69->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl69);
sMM->cls->push_back (cl69);
	
	Clause* cl70 = new Clause (VC);
	cl70->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl70->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl70->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl70);
sMM->cls->push_back (cl70);
	
	Clause* cl71 = new Clause (VC);
	cl71->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl71->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl71->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl71);
sMM->cls->push_back (cl71);
	
	Clause* cl72 = new Clause (VC);
	cl72->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl72->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl72->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl72);
sMM->cls->push_back (cl72);
	
	Clause* cl73 = new Clause (VC);
	cl73->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl73->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl73->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl73);
sMM->cls->push_back (cl73);
	
	Clause* cl74 = new Clause (VC);
	cl74->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl74->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl74->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl74);
sMM->cls->push_back (cl74);
	
	Clause* cl75 = new Clause (VC);
	cl75->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl75->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl75->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl75);
sMM->cls->push_back (cl75);
	
	Clause* cl76 = new Clause (VC);
	cl76->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl76->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl76->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl76);
sMM->cls->push_back (cl76);
	
	Clause* cl77 = new Clause (VC);
	cl77->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl77->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl77->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl77);
sMM->cls->push_back (cl77);
	
	Clause* cl78 = new Clause (VC);
	cl78->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl78->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl78->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl78);
sMM->cls->push_back (cl78);
	
	Clause* cl79 = new Clause (VC);
	cl79->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl79->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl79->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl79);
sMM->cls->push_back (cl79);
	
	Clause* cl80 = new Clause (VC);
	cl80->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl80->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl80->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl80);
sMM->cls->push_back (cl80);
	
	Clause* cl81 = new Clause (VC);
	cl81->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl81->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl81->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl81);
sMM->cls->push_back (cl81);
	
	Clause* cl82 = new Clause (VC);
	cl82->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl82->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl82->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl82);
sMM->cls->push_back (cl82);
	
	Clause* cl83 = new Clause (VC);
	cl83->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl83->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl83->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl83);
sMM->cls->push_back (cl83);
	
	Clause* cl84 = new Clause (VC);
	cl84->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl84->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl84->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl84);
sMM->cls->push_back (cl84);
	
	Clause* cl85 = new Clause (VC);
	cl85->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl85->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl85->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl85);
sMM->cls->push_back (cl85);
	
	Clause* cl86 = new Clause (VC);
	cl86->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl86->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl86->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl86);
sMM->cls->push_back (cl86);
	
	Clause* cl87 = new Clause (VC);
	cl87->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl87->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl87->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl87);
sMM->cls->push_back (cl87);
	
	Clause* cl88 = new Clause (VC);
	cl88->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl88->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl88->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl88);
sMM->cls->push_back (cl88);
	
	Clause* cl89 = new Clause (VC);
	cl89->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl89->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl89->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl89);
sMM->cls->push_back (cl89);
	
	Clause* cl90 = new Clause (VC);
	cl90->addAtomRef(VC->valve_cont_cmdin_fl, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_fso, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_fsc, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_v2_close, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_v2_open, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_v1_close, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_v1_open, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_v1_off, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_v1_on, false);
	cl90->addAtomRef(VC->valve_cont_cmdin_none, false);
	cl90->setInternal(1);
	VC->valve_cont_cmdin->internal_clauses->push_back(cl90);
sMM->cls->push_back (cl90);
	
	Clause* cl91 = new Clause (VC);
	cl91->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl91->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl91->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl91);
sMM->cls->push_back (cl91);
	
	Clause* cl92 = new Clause (VC);
	cl92->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl92->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl92->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl92);
sMM->cls->push_back (cl92);
	
	Clause* cl93 = new Clause (VC);
	cl93->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl93->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl93->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl93);
sMM->cls->push_back (cl93);
	
	Clause* cl94 = new Clause (VC);
	cl94->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl94->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl94->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl94);
sMM->cls->push_back (cl94);
	
	Clause* cl95 = new Clause (VC);
	cl95->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl95->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl95->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl95);
sMM->cls->push_back (cl95);
	
	Clause* cl96 = new Clause (VC);
	cl96->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl96->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl96->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl96);
sMM->cls->push_back (cl96);
	
	Clause* cl97 = new Clause (VC);
	cl97->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl97->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl97->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl97);
sMM->cls->push_back (cl97);
	
	Clause* cl98 = new Clause (VC);
	cl98->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl98->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl98->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl98);
sMM->cls->push_back (cl98);
	
	Clause* cl99 = new Clause (VC);
	cl99->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl99->addAtomRef(VC->valve_cont_cmdout_none, true);
	cl99->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl99);
sMM->cls->push_back (cl99);
	
	Clause* cl100 = new Clause (VC);
	cl100->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl100->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl100->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl100);
sMM->cls->push_back (cl100);
	
	Clause* cl101 = new Clause (VC);
	cl101->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl101->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl101->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl101);
sMM->cls->push_back (cl101);
	
	Clause* cl102 = new Clause (VC);
	cl102->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl102->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl102->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl102);
sMM->cls->push_back (cl102);
	
	Clause* cl103 = new Clause (VC);
	cl103->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl103->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl103->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl103);
sMM->cls->push_back (cl103);
	
	Clause* cl104 = new Clause (VC);
	cl104->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl104->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl104->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl104);
sMM->cls->push_back (cl104);
	
	Clause* cl105 = new Clause (VC);
	cl105->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl105->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl105->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl105);
sMM->cls->push_back (cl105);
	
	Clause* cl106 = new Clause (VC);
	cl106->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl106->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl106->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl106);
sMM->cls->push_back (cl106);
	
	Clause* cl107 = new Clause (VC);
	cl107->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl107->addAtomRef(VC->valve_cont_cmdout_v1_on, true);
	cl107->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl107);
sMM->cls->push_back (cl107);
	
	Clause* cl108 = new Clause (VC);
	cl108->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl108->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl108->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl108);
sMM->cls->push_back (cl108);
	
	Clause* cl109 = new Clause (VC);
	cl109->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl109->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl109->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl109);
sMM->cls->push_back (cl109);
	
	Clause* cl110 = new Clause (VC);
	cl110->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl110->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl110->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl110);
sMM->cls->push_back (cl110);
	
	Clause* cl111 = new Clause (VC);
	cl111->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl111->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl111->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl111);
sMM->cls->push_back (cl111);
	
	Clause* cl112 = new Clause (VC);
	cl112->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl112->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl112->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl112);
sMM->cls->push_back (cl112);
	
	Clause* cl113 = new Clause (VC);
	cl113->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl113->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl113->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl113);
sMM->cls->push_back (cl113);
	
	Clause* cl114 = new Clause (VC);
	cl114->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl114->addAtomRef(VC->valve_cont_cmdout_v1_off, true);
	cl114->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl114);
sMM->cls->push_back (cl114);
	
	Clause* cl115 = new Clause (VC);
	cl115->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl115->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl115->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl115);
sMM->cls->push_back (cl115);
	
	Clause* cl116 = new Clause (VC);
	cl116->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl116->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl116->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl116);
sMM->cls->push_back (cl116);
	
	Clause* cl117 = new Clause (VC);
	cl117->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl117->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl117->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl117);
sMM->cls->push_back (cl117);
	
	Clause* cl118 = new Clause (VC);
	cl118->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl118->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl118->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl118);
sMM->cls->push_back (cl118);
	
	Clause* cl119 = new Clause (VC);
	cl119->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl119->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl119->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl119);
sMM->cls->push_back (cl119);
	
	Clause* cl120 = new Clause (VC);
	cl120->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl120->addAtomRef(VC->valve_cont_cmdout_v1_open, true);
	cl120->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl120);
sMM->cls->push_back (cl120);
	
	Clause* cl121 = new Clause (VC);
	cl121->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl121->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl121->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl121);
sMM->cls->push_back (cl121);
	
	Clause* cl122 = new Clause (VC);
	cl122->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl122->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl122->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl122);
sMM->cls->push_back (cl122);
	
	Clause* cl123 = new Clause (VC);
	cl123->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl123->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl123->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl123);
sMM->cls->push_back (cl123);
	
	Clause* cl124 = new Clause (VC);
	cl124->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl124->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl124->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl124);
sMM->cls->push_back (cl124);
	
	Clause* cl125 = new Clause (VC);
	cl125->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl125->addAtomRef(VC->valve_cont_cmdout_v1_close, true);
	cl125->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl125);
sMM->cls->push_back (cl125);
	
	Clause* cl126 = new Clause (VC);
	cl126->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl126->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl126->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl126);
sMM->cls->push_back (cl126);
	
	Clause* cl127 = new Clause (VC);
	cl127->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl127->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl127->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl127);
sMM->cls->push_back (cl127);
	
	Clause* cl128 = new Clause (VC);
	cl128->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl128->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl128->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl128);
sMM->cls->push_back (cl128);
	
	Clause* cl129 = new Clause (VC);
	cl129->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl129->addAtomRef(VC->valve_cont_cmdout_v2_open, true);
	cl129->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl129);
sMM->cls->push_back (cl129);
	
	Clause* cl130 = new Clause (VC);
	cl130->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl130->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl130->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl130);
sMM->cls->push_back (cl130);
	
	Clause* cl131 = new Clause (VC);
	cl131->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl131->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl131->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl131);
sMM->cls->push_back (cl131);
	
	Clause* cl132 = new Clause (VC);
	cl132->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl132->addAtomRef(VC->valve_cont_cmdout_v2_close, true);
	cl132->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl132);
sMM->cls->push_back (cl132);
	
	Clause* cl133 = new Clause (VC);
	cl133->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl133->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl133->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl133);
sMM->cls->push_back (cl133);
	
	Clause* cl134 = new Clause (VC);
	cl134->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl134->addAtomRef(VC->valve_cont_cmdout_fsc, true);
	cl134->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl134);
sMM->cls->push_back (cl134);
	
	Clause* cl135 = new Clause (VC);
	cl135->addAtomRef(VC->valve_cont_cmdout_fl, true);
	cl135->addAtomRef(VC->valve_cont_cmdout_fso, true);
	cl135->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl135);
sMM->cls->push_back (cl135);
	
	Clause* cl136 = new Clause (VC);
	cl136->addAtomRef(VC->valve_cont_cmdout_fl, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_fso, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_fsc, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_v2_close, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_v2_open, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_v1_close, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_v1_open, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_v1_off, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_v1_on, false);
	cl136->addAtomRef(VC->valve_cont_cmdout_none, false);
	cl136->setInternal(1);
	VC->valve_cont_cmdout->internal_clauses->push_back(cl136);
sMM->cls->push_back (cl136);
	
	Clause* cl137 = new Clause (VC);
	cl137->addAtomRef(VC->valve_cont_mode_failed, true);
	cl137->addAtomRef(VC->valve_cont_mode_ok, true);
	cl137->setInternal(1);
	VC->valve_cont_mode->internal_clauses->push_back(cl137);
sMM->cls->push_back (cl137);
	
	Clause* cl138 = new Clause (VC);
	cl138->addAtomRef(VC->valve_cont_mode_unknown, true);
	cl138->addAtomRef(VC->valve_cont_mode_ok, true);
	cl138->setInternal(1);
	VC->valve_cont_mode->internal_clauses->push_back(cl138);
sMM->cls->push_back (cl138);
	
	Clause* cl139 = new Clause (VC);
	cl139->addAtomRef(VC->valve_cont_mode_unknown, true);
	cl139->addAtomRef(VC->valve_cont_mode_failed, true);
	cl139->setInternal(1);
	VC->valve_cont_mode->internal_clauses->push_back(cl139);
sMM->cls->push_back (cl139);
	
	Clause* cl140 = new Clause (VC);
	cl140->addAtomRef(VC->valve_cont_mode_unknown, false);
	cl140->addAtomRef(VC->valve_cont_mode_failed, false);
	cl140->addAtomRef(VC->valve_cont_mode_ok, false);
	cl140->setInternal(1);
	VC->valve_cont_mode->internal_clauses->push_back(cl140);
sMM->cls->push_back (cl140);
	
	Clause* cl141 = new Clause (VC);
	cl141->addAtomRef(VC->valve_cont_mode_ok, true);
	cl141->addAtomRef(VC->valve_cont_cmdin_fl, true);
	cl141->addAtomRef(VC->valve_cont_cmdout_fl, false);
	cl141->setInternal(0);
	VC->external_clauses->push_back(cl141);
	sMM->cls->push_back (cl141);
	
	Clause* cl142 = new Clause (VC);
	cl142->addAtomRef(VC->valve_cont_mode_ok, true);
	cl142->addAtomRef(VC->valve_cont_cmdin_fso, true);
	cl142->addAtomRef(VC->valve_cont_cmdout_fso, false);
	cl142->setInternal(0);
	VC->external_clauses->push_back(cl142);
	sMM->cls->push_back (cl142);
	
	Clause* cl143 = new Clause (VC);
	cl143->addAtomRef(VC->valve_cont_mode_ok, true);
	cl143->addAtomRef(VC->valve_cont_cmdin_fsc, true);
	cl143->addAtomRef(VC->valve_cont_cmdout_fsc, false);
	cl143->setInternal(0);
	VC->external_clauses->push_back(cl143);
	sMM->cls->push_back (cl143);
	
	Clause* cl144 = new Clause (VC);
	cl144->addAtomRef(VC->valve_cont_mode_ok, true);
	cl144->addAtomRef(VC->valve_cont_cmdin_v2_close, true);
	cl144->addAtomRef(VC->valve_cont_cmdout_v2_close, false);
	cl144->setInternal(0);
	VC->external_clauses->push_back(cl144);
	sMM->cls->push_back (cl144);
	
	Clause* cl145 = new Clause (VC);
	cl145->addAtomRef(VC->valve_cont_mode_ok, true);
	cl145->addAtomRef(VC->valve_cont_cmdin_v2_open, true);
	cl145->addAtomRef(VC->valve_cont_cmdout_v2_open, false);
	cl145->setInternal(0);
	VC->external_clauses->push_back(cl145);
	sMM->cls->push_back (cl145);
	
	Clause* cl146 = new Clause (VC);
	cl146->addAtomRef(VC->valve_cont_mode_ok, true);
	cl146->addAtomRef(VC->valve_cont_cmdin_v1_close, true);
	cl146->addAtomRef(VC->valve_cont_cmdout_v1_close, false);
	cl146->setInternal(0);
	VC->external_clauses->push_back(cl146);
	sMM->cls->push_back (cl146);
	
	Clause* cl147 = new Clause (VC);
	cl147->addAtomRef(VC->valve_cont_mode_ok, true);
	cl147->addAtomRef(VC->valve_cont_cmdin_v1_open, true);
	cl147->addAtomRef(VC->valve_cont_cmdout_v1_open, false);
	cl147->setInternal(0);
	VC->external_clauses->push_back(cl147);
	sMM->cls->push_back (cl147);
	
	Clause* cl148 = new Clause (VC);
	cl148->addAtomRef(VC->valve_cont_mode_ok, true);
	cl148->addAtomRef(VC->valve_cont_cmdin_v1_off, true);
	cl148->addAtomRef(VC->valve_cont_cmdout_v1_off, false);
	cl148->setInternal(0);
	VC->external_clauses->push_back(cl148);
	sMM->cls->push_back (cl148);
	
	Clause* cl149 = new Clause (VC);
	cl149->addAtomRef(VC->valve_cont_mode_ok, true);
	cl149->addAtomRef(VC->valve_cont_cmdin_v1_on, true);
	cl149->addAtomRef(VC->valve_cont_cmdout_v1_on, false);
	cl149->setInternal(0);
	VC->external_clauses->push_back(cl149);
	sMM->cls->push_back (cl149);
	
	Clause* cl150 = new Clause (VC);
	cl150->addAtomRef(VC->valve_cont_mode_ok, true);
	cl150->addAtomRef(T2->tank2_c1_c12, true);
	cl150->addAtomRef(VC->valve_cont_cmdout_v1_close, false);
	cl150->setInternal(0);
	VC->external_clauses->push_back(cl150);
	sMM->cls->push_back (cl150);
	
	Clause* cl151 = new Clause (VC);
	cl151->addAtomRef(VC->valve_cont_mode_ok, true);
	cl151->addAtomRef(T2->tank2_c1_c10, true);
	cl151->addAtomRef(VC->valve_cont_cmdout_v1_open, false);
	cl151->setInternal(0);
	VC->external_clauses->push_back(cl151);
	sMM->cls->push_back (cl151);
	/* cross-reference code */
	P1->imported_comps->push_back (T1);
	P1->i_i1->cause = T1->h;
	P1->k_1[0] = T1->i_i8;
	P1->k_1[1] = T1->i_i1;
	T1->imported_comps->push_back (P1);
	T1->imported_comps->push_back (V1);
	T1->imported_comps->push_back (V2);
	T1->i_i1->cause = P1->Q1p1;
	T1->i_i2->cause = V1->Q1v13;
	T1->i_i3->cause = V2->Q13v13;
	T1->i_i8->cause = P1->Q1p1;
	T1->i_i9->cause = V1->Q1v13;
	T1->i_i10->cause = V2->Q13v13;
	T1->k_1[0] = P1->i_i1;
	T1->k_1[2] = V1->i_i4;
	T1->k_1[3] = V1->i_i7;
	T1->k_1[4] = V2->i_i4;
		T1->tank1_stf12->addAtom (VC->valve_cont_cmdout_fl, 1);
	T1->tank1_t6->refAtomPre (1, VC->valve_cont_cmdout_fl);
T2->imported_comps->push_back (V1);
	T2->imported_comps->push_back (V2);
	T2->i_i1->cause = V1->Q1v13;
	T2->i_i2->cause = V2->Q13v13;
	T2->k_1[1] = V1->i_i3;
	T2->k_1[2] = V1->i_i8;
	T2->k_1[3] = V2->i_i5;
	V1->imported_comps->push_back (T1);
	V1->imported_comps->push_back (T2);
	V1->f_19->uv.var = T2->hi3;
	V1->c_9->op1=T2->c_1;
	V1->c_9->op2=T1->c_1;
	V1->c_10->op1=T2->c_2;
	V1->c_10->op2=T1->c_1;
	V1->i_i3->cause = T2->h;
	V1->c_11->op1=T2->c_1;
	V1->c_11->op2=T1->c_2;
	V1->i_i4->cause = T1->h;
	V1->c_12->op1=T2->c_2;
	V1->c_12->op2=T1->c_2;
	V1->i_i7->cause = T1->h;
	V1->i_i8->cause = T2->h;
	V1->k_1[0] = T1->i_i9;
	V1->k_1[1] = T1->i_i2;
	V1->k_1[2] = T2->i_i1;
		V1->valve_up_stf26->addAtom (VC->valve_cont_cmdout_fso, 1);
	V1->valve_up_t13->refAtomPre (1, VC->valve_cont_cmdout_fso);
	V1->valve_up_stf28->addAtom (VC->valve_cont_cmdout_fsc, 1);
	V1->valve_up_t14->refAtomPre (1, VC->valve_cont_cmdout_fsc);
	V1->valve_up_stf38->addAtom ((*VC->atoms)["valve_cont_cmdout_v1_close"], 1);
	V1->valve_up_t19->refAtomPre (1, VC->valve_cont_cmdout_v1_close);
(*V1->valve_up_t19->mf)[0]->mvs->push_back (mkMapfVar (getVarName (T2->hi1), 1));
	(*V1->valve_up_t19->mf)[0]->mvs->push_back (mkMapfVar (getVarName (T2->h), 2));
		V1->valve_up_stf40->addAtom ((*VC->atoms)["valve_cont_cmdout_v1_open"], 1);
	V1->valve_up_t20->refAtomPre (1, VC->valve_cont_cmdout_v1_open);
(*V1->valve_up_t20->mf)[0]->mvs->push_back (mkMapfVar (getVarName (T2->hi1), 4));
	(*V1->valve_up_t20->mf)[0]->mvs->push_back (mkMapfVar (getVarName (T2->h), 5));
	V1->s_53->gv = T2->f_5;
	(*V1->valve_up_t20->mf)[1]->mvs->push_back (mkMapfVar (getVarName (T2->hi1), 7));
	(*V1->valve_up_t20->mf)[1]->mvs->push_back (mkMapfVar (getVarName (T2->h), 8));
	V1->s_67->gv = T1->f_0;
	(*V1->valve_up_t20->mf)[2]->mvs->push_back (mkMapfVar (getVarName (T2->hi1), 10));
	(*V1->valve_up_t20->mf)[2]->mvs->push_back (mkMapfVar (getVarName (T2->h), 11));
	(*V1->valve_up_t20->mf)[3]->mvs->push_back (mkMapfVar (getVarName (T2->hi1), 13));
	(*V1->valve_up_t20->mf)[4]->mvs->push_back (mkMapfVar (getVarName (T2->hi1), 15));
	V2->imported_comps->push_back (T1);
	V2->imported_comps->push_back (T2);
	V2->i_i4->cause = T1->h;
	V2->i_i5->cause = T2->h;
	V2->k_1[0] = T1->i_i10;
	V2->k_1[1] = T1->i_i3;
	V2->k_1[2] = T2->i_i2;
		V2->valve_down_stf46->addAtom ((*VC->atoms)["valve_cont_cmdout_v2_close"], 1);
	V2->valve_down_t23->refAtomPre (1, VC->valve_cont_cmdout_v2_close);
	V2->valve_down_stf48->addAtom ((*VC->atoms)["valve_cont_cmdout_v2_open"], 1);
	V2->valve_down_t24->refAtomPre (1, VC->valve_cont_cmdout_v2_open);
VC->imported_comps->push_back (T2);
	
	dico = (variable*) new_malloc (41*sizeof (variable));
	dico[0] = P1->Q1p1;
	dico[1] = P1->h1;
	dico[2] = P1->h1i;
	dico[3] = P1->zero;
	dico[4] = P1->Kp;
	dico[5] = P1->Ki;
	dico[6] = P1->w1;
	dico[7] = T1->h;
	dico[8] = T1->hi1;
	dico[9] = T1->hi2;
	dico[10] = T1->hi3;
	dico[11] = T1->hi4;
	dico[12] = T1->Qleak;
	dico[13] = T1->A;
	dico[14] = T1->invA;
	dico[15] = T1->minvA;
	dico[16] = T1->R7;
	dico[17] = T2->h;
	dico[18] = T2->hi1;
	dico[19] = T2->hi2;
	dico[20] = T2->hi3;
	dico[21] = T2->Qn;
	dico[22] = T2->A;
	dico[23] = T2->invA;
	dico[24] = T2->R7;
	dico[25] = V1->Q1v13;
	dico[26] = V1->h13;
	dico[27] = V1->zero;
	dico[28] = V1->R3;
	dico[29] = V1->R4;
	dico[30] = V1->R51;
	dico[31] = V1->R52;
	dico[32] = V1->g;
	dico[33] = V1->az;
	dico[34] = V1->S;
	dico[35] = V1->A;
	dico[36] = V2->Q13v13;
	dico[37] = V2->h13;
	dico[38] = V2->zero;
	dico[39] = V2->R21;
	dico[40] = V2->R22;
	
	display = (variable*) new_malloc (3*sizeof (variable));
	display[0] = P1->Q1p1;
	display[1] = T1->h;
	display[2] = T2->h;
	dinfval = (double*) new_malloc (3*sizeof(double));
	dsupval = (double*) new_malloc (3*sizeof(double));
	temporal = (variable*) new_malloc (8*sizeof (variable));
	temporal[0] = P1->h1i;
	temporal[1] = T1->hi1;
	temporal[2] = T1->hi2;
	temporal[3] = T1->hi3;
	temporal[4] = T1->hi4;
	temporal[5] = T2->hi1;
	temporal[6] = T2->hi2;
	temporal[7] = T2->hi3;
	untemporal = (variable*) new_malloc (10*sizeof (variable));
	untemporal[0] = T1->h;
	untemporal[1] = T2->h;
	untemporal[2] = P1->h1;
	untemporal[3] = T1->Qleak;
	untemporal[4] = T2->Qn;
	untemporal[5] = V1->h13;
	untemporal[6] = V2->h13;
	untemporal[7] = P1->Q1p1;
	untemporal[8] = V1->Q1v13;
	untemporal[9] = V2->Q13v13;
	
	influ = (influence*) new_malloc (41*sizeof (influence));
	influ[0] = P1->i_i1;
	influ[1] = P1->i_i2;
	influ[2] = P1->i_i3;
	influ[3] = P1->i_i4;
	influ[4] = P1->i_i5;
	influ[5] = P1->i_i6;
	influ[6] = T1->i_i1;
	influ[7] = T1->i_i2;
	influ[8] = T1->i_i3;
	influ[9] = T1->i_i4;
	influ[10] = T1->i_i5;
	influ[11] = T1->i_i6;
	influ[12] = T1->i_i7;
	influ[13] = T1->i_i8;
	influ[14] = T1->i_i9;
	influ[15] = T1->i_i10;
	influ[16] = T1->i_i11;
	influ[17] = T1->i_i12;
	influ[18] = T1->i_i13;
	influ[19] = T1->i_i14;
	influ[20] = T1->i_i15;
	influ[21] = T2->i_i1;
	influ[22] = T2->i_i2;
	influ[23] = T2->i_i3;
	influ[24] = T2->i_i4;
	influ[25] = T2->i_i5;
	influ[26] = T2->i_i6;
	influ[27] = T2->i_i7;
	influ[28] = V1->i_i1;
	influ[29] = V1->i_i2;
	influ[30] = V1->i_i3;
	influ[31] = V1->i_i4;
	influ[32] = V1->i_i5;
	influ[33] = V1->i_i6;
	influ[34] = V1->i_i7;
	influ[35] = V1->i_i8;
	influ[36] = V2->i_i1;
	influ[37] = V2->i_i2;
	influ[38] = V2->i_i3;
	influ[39] = V2->i_i4;
	influ[40] = V2->i_i5;
	condin = (long*) new_malloc (41*sizeof (long));
	condout = (long*) new_malloc (41*sizeof (long));
	condi = (condition*) new_malloc (51*sizeof (condition));
	condi[0] = P1->c_1;
	condi[1] = P1->c_2;
	condi[2] = P1->c_3;
	condi[3] = T1->c_2;
	condi[4] = T1->c_1;
	condi[5] = T1->c_3;
	condi[6] = T1->c_4;
	condi[7] = T1->c_5;
	condi[8] = T2->c_7;
	condi[9] = T2->c_4;
	condi[10] = T2->c_5;
	condi[11] = T2->c_6;
	condi[12] = T2->c_3;
	condi[13] = T2->c_2;
	condi[14] = T2->c_1;
	condi[15] = T2->c_8;
	condi[16] = T2->c_9;
	condi[17] = V1->c_2;
	condi[18] = V1->c_1;
	condi[19] = V1->c_3;
	condi[20] = V1->c_4;
	condi[21] = V1->c_5;
	condi[22] = V1->c_6;
	condi[23] = V1->c_7;
	condi[24] = V1->c_8;
	condi[25] = V1->c_15;
	condi[26] = V1->c_9;
	condi[27] = V1->c_16;
	condi[28] = V1->c_10;
	condi[29] = V1->c_17;
	condi[30] = V1->c_11;
	condi[31] = V1->c_18;
	condi[32] = V1->c_13;
	condi[33] = V1->c_12;
	condi[34] = V1->c_14;
	condi[35] = V1->c_19;
	condi[36] = V1->c_20;
	condi[37] = V2->c_2;
	condi[38] = V2->c_1;
	condi[39] = V2->c_3;
	condi[40] = V2->c_4;
	condi[41] = V2->c_5;
	condi[42] = V2->c_6;
	condi[43] = V2->c_7;
	condi[44] = V2->c_8;
	condi[45] = V2->c_9;
	condi[46] = V2->c_10;
	condi[47] = V2->c_11;
	condi[48] = VC->c_1;
	condi[49] = VC->c_2;
	condi[50] = VC->c_3;
	cG = (cGraph*) new_malloc (22*sizeof (cGraph));
	cG[0] = P1->pump_n_1;
	cG[1] = P1->pump_n_2;
	cG[2] = P1->pump_n_3;
	cG[3] = P1->pump_n_4;
	cG[4] = P1->pump_n_7;
	cG[5] = T1->tank1_n_1;
	cG[6] = T1->tank1_n_2;
	cG[7] = T1->tank1_n_3;
	cG[8] = T1->tank1_n_4;
	cG[9] = T1->tank1_n_5;
	cG[10] = T1->tank1_n_6;
	cG[11] = T2->tank2_n_1;
	cG[12] = T2->tank2_n_2;
	cG[13] = T2->tank2_n_3;
	cG[14] = T2->tank2_n_4;
	cG[15] = T2->tank2_n_5;
	cG[16] = V1->valve_up_n_1;
	cG[17] = V1->valve_up_n_2;
	cG[18] = V1->valve_up_n_3;
	cG[19] = V2->valve_down_n_1;
	cG[20] = V2->valve_down_n_2;
	cG[21] = V2->valve_down_n_3;
	init = (initVar*) new_malloc (16*sizeof (initVar));
	init[0] = P1->h_1;
	init[1] = T1->h_2;
	init[2] = T1->h_3;
	init[3] = T1->h_4;
	init[4] = T1->h_5;
	init[5] = T1->h_6;
	init[6] = T1->h_7;
	init[7] = T2->h_8;
	init[8] = T2->h_9;
	init[9] = T2->h_10;
	init[10] = T2->h_11;
	init[11] = T2->h_12;
	init[12] = V1->h_13;
	init[13] = V1->h_14;
	init[14] = V2->h_15;
	init[15] = V2->h_16;
	gV = (gVar*) new_malloc (26*sizeof (gVar));
	gV[0] = T1->f_0;
	gV[1] = T2->f_5;
	gV[2] = V1->f_18;
	gV[3] = V1->f_19;
	gV[4] = V1->f_20;
	gV[5] = V1->f_21;
	gV[6] = V1->f_22;
	gV[7] = V1->f_23;
	gV[8] = V1->f_24;
	gV[9] = V1->f_25;
	gV[10] = V1->f_26;
	gV[11] = V1->f_27;
	gV[12] = V1->f_28;
	gV[13] = V1->f_29;
	gV[14] = V1->f_30;
	gV[15] = V1->f_31;
	gV[16] = V1->f_32;
	gV[17] = V1->f_33;
	gV[18] = V1->f_34;
	gV[19] = V1->f_35;
	gV[20] = V1->f_36;
	gV[21] = V1->f_37;
	gV[22] = V1->f_38;
	gV[23] = V1->f_39;
	gV[24] = V1->f_40;
	gV[25] = V2->f_71;
	aC = (expr*) new_malloc (12*sizeof (expr));
	aC[0] = T1->s_1;
	aC[1] = T1->s_4;
	aC[2] = T2->s_7;
	aC[3] = T2->s_10;
	aC[4] = T2->s_13;
	aC[5] = T2->s_16;
	aC[6] = T2->s_19;
	aC[7] = T2->s_22;
	aC[8] = V1->s_25;
	aC[9] = V1->s_28;
	aC[10] = V2->s_96;
	aC[11] = V2->s_99;
	long* vals = (long*) new_malloc (12*sizeof (long));
	vals[1] = 0;
	vals[2] = 0;
	vals[3] = 0;
	vals[4] = 0;
	vals[5] = 0;
	vals[6] = 0;
	vals[7] = 0;
	vals[8] = 0;
	vals[9] = 0;
	vals[10] = 0;
	vals[11] = 0;
	long* inAc = (long*) new_malloc (12*sizeof (long));
	inAc[0] = 0;
	inAc[1] = 0;
	inAc[2] = 0;
	inAc[3] = 0;
	inAc[4] = 0;
	inAc[5] = 0;
	inAc[6] = 0;
	inAc[7] = 0;
	inAc[8] = 0;
	inAc[9] = 0;
	inAc[10] = 0;
	inAc[11] = 0;
	expr* aMF = (expr*) new_malloc (16*sizeof (expr));
	aMF[0] = V1->s_31;
	aMF[1] = V1->s_32;
	aMF[2] = V1->s_37;
	aMF[3] = V1->s_38;
	aMF[4] = V1->s_39;
	aMF[5] = V1->s_42;
	aMF[6] = V1->s_43;
	aMF[7] = V1->s_56;
	aMF[8] = V1->s_59;
	aMF[9] = V1->s_60;
	aMF[10] = V1->s_70;
	aMF[11] = V1->s_73;
	aMF[12] = V1->s_74;
	aMF[13] = V1->s_83;
	aMF[14] = V1->s_86;
	aMF[15] = V1->s_93;
	tanks_rt = (runtime) new_malloc (sizeof (s_runtime));
	tanks_rt->appli = "tanks";
	tanks_rt->num = 0;
	tanks_rt->ts = 1;
	tanks_rt->dts = 0;
	tanks_rt->twc = 300;
	tanks_rt->nvar = 41;
	tanks_rt->dico = dico;
	tanks_rt->nin = 0;
	tanks_rt->in = NULL;
	tanks_rt->inval = NULL;
	tanks_rt->ndisp = 3;
	tanks_rt->disp = display;
	tanks_rt->dispinfval = dinfval;
	tanks_rt->dispsupval = dsupval;
	tanks_rt->ndispall = 0;
	tanks_rt->dispall = NULL;
	tanks_rt->nmes = 0;
	tanks_rt->mes = NULL;
	tanks_rt->mesval = NULL;
	tanks_rt->lowalarm = NULL;
	tanks_rt->highalarm = NULL;
	tanks_rt->lowmisb = NULL;
	tanks_rt->highmisb = NULL;
	tanks_rt->misb = NULL;
	tanks_rt->ntemp = 8;
	tanks_rt->temp = temporal;
	tanks_rt->nuntemp = 10;
	tanks_rt->untemp = untemporal;
	tanks_rt->nifl = 41;
	tanks_rt->infl = influ;
	tanks_rt->condin = condin;
	tanks_rt->condout = condout;
	tanks_rt->ncg = 22;
	tanks_rt->cg = cG;
	tanks_rt->maxDepth = 3;
	tanks_rt->nit = 16;
	tanks_rt->iv = init;
	tanks_rt->ngv = 26;
	tanks_rt->vgv = gV;
	tanks_rt->ngc = 0;
	tanks_rt->glc = NULL;
	tanks_rt->inag = NULL;
	tanks_rt->ncdc = 12;
	tanks_rt->cdc = aC;
	tanks_rt->valSpc = vals;
	tanks_rt->inac = inAc;
	tanks_rt->nmfc = 16;
	tanks_rt->mfc = aMF;
	tanks_rt->inited = 0;
	tanks_rt->runGC = 0;
	tanks_rt->cumTime = 0;
	tanks_rt->prec = 0;
	tanks_rt->onlyFaultIso = 0;
	tanks_rt->numMisb = 0;
	tanks_rt->numOk = 0;
	tanks_rt->mbVA = NULL;
	tanks_rt->okVA = NULL;
	tanks_rt->sfVA = NULL;
	tanks_rt->oldNumMisb = 0;
	tanks_rt->oldMisbVarArray = NULL;
	tanks_rt->numNodesHST = 0;tanks_rt->ncondi = 51;
	tanks_rt->condi = condi;
	tanks_rt->bridgeEvents = NULL;
	tanks_rt->bridgeConds = NULL;
	tanks_rt->bridgeTransitions = NULL;tanks_rt->bridgeConflicts = NULL;
	createLeafListcaen (&tanks_rt->HSTree);
	createConflictSet (&tanks_rt->softConflictListcaen);
	tanks_rt->diagOut = NULL;
	
/* remove next line if linking several applications 		       together */
koala_rt=tanks_rt;
	}
bool env_opti = 1;
long guards_int = 1;
	int Trajectory::twd = 5;
	long h_pi = 0;
	string model_name = "tanks";
	