#include "valve.h"

valve::valve(string na, vector<CommandVar*>* in, vector<CommandVar*>* out) : Comp(na) {
		cmd_in = in;
		cmpin = (vdu*) (*cmd_in)[0]->comp_lk;
		cmd_out = out;
	init();
}
valve::~valve() {

}
void valve::init() {

	set<string> valve_vflow_values;
	valve_vflow_values.insert("nonzero");
	valve_vflow_values.insert("zero");
	string vflowname = name + ".vflow";
	valve_vflow = new ObsVar(vflowname, valve_vflow_values, "zero", this);
		addStateVar(valve_vflow);

	valve_vflow_zero = new Atom(valve_vflow, "zero", name + ".vflow=zero");
		(*atoms)["valve_vflow_zero"]=valve_vflow_zero;
		valve_vflow_nonzero = new Atom(valve_vflow, "nonzero", name + ".vflow=nonzero");
		(*atoms)["valve_vflow_nonzero"]=valve_vflow_nonzero;
	
	set<string> valve_mode_values;
	valve_mode_values.insert("closed");
	valve_mode_values.insert("open");
	valve_mode_values.insert("stuck_closed");
	valve_mode_values.insert("stuck_open");
	string modename = name + ".mode";
	valve_mode = new ModeVar(modename, valve_mode_values, "closed", this);
		addStateVar(valve_mode);

	valve_mode_closed = new Atom(valve_mode, "closed", name + ".mode=closed");
		(*atoms)["valve_mode_closed"]=valve_mode_closed;
		valve_mode_open = new Atom(valve_mode, "open", name + ".mode=open");
		(*atoms)["valve_mode_open"]=valve_mode_open;
		valve_mode_stuck_open = new Atom(valve_mode, "stuck_open", name + ".mode=stuck_open");
		(*atoms)["valve_mode_stuck_open"]=valve_mode_stuck_open;
		valve_mode_stuck_closed = new Atom(valve_mode, "stuck_closed", name + ".mode=stuck_closed");
		(*atoms)["valve_mode_stuck_closed"]=valve_mode_stuck_closed;
	c_5 = mkCond ();
	setCondType (c_5, 6);
	setCondCTE (c_5, 0);
	setCondAtom (c_5, valve_mode_closed);
	;
	c_6 = mkCond ();
	setCondType (c_6, 6);
	setCondCTE (c_6, 0);
	setCondAtom (c_6, valve_mode_open);
	;
	c_7 = mkCond ();
	setCondType (c_7, 6);
	setCondCTE (c_7, 0);
	setCondAtom (c_7, valve_mode_stuck_open);
	;
	c_8 = mkCond ();
	setCondType (c_8, 6);
	setCondCTE (c_8, 0);
	setCondAtom (c_8, valve_mode_stuck_closed);
	;
		valve_mode->conditions->insert(pair<const char*, int>(valve_mode_closed->getId(), 0));
	valve_mode_closed->cond = 1;
		valve_mode->conditions->insert(pair<const char*, int>(valve_mode_open->getId(), 1));
	valve_mode_open->cond = 1;
		valve_mode->conditions->insert(pair<const char*, int>(valve_mode_stuck_open->getId(), 2));
	valve_mode_stuck_open->cond = 1;
		valve_mode->conditions->insert(pair<const char*, int>(valve_mode_stuck_closed->getId(), 3));
	valve_mode_stuck_closed->cond = 1;
		external_clauses = new vector<Clause*>();

	valve_stf0 = new StateFormula();
	valve_stf0->addAtom (valve_mode_closed, 1);
 /* gen */
	valve_stf0->setOperat("");

	valve_stf1 = new StateFormula();
	valve_stf1->addAtom (valve_mode_stuck_closed, 1);
 /* gen */
	valve_stf1->setOperat("");

	valve_t0 = new Transition(valve_stf0, valve_stf1, "Fail", 0.1, 0, 0);
valve_t0->trans_id = 0;
	
	addTransitionToC(valve_t0);
	
	valve_stf2 = new StateFormula();
	valve_stf2->addAtom (valve_mode_open, 1);
 /* gen */
	valve_stf2->setOperat("");

	valve_stf3 = new StateFormula();
	valve_stf3->addAtom (valve_mode_stuck_open, 1);
 /* gen */
	valve_stf3->setOperat("");

	valve_t1 = new Transition(valve_stf2, valve_stf3, "Fail", 0.01, 0, 0);
valve_t1->trans_id = 1;
	
	addTransitionToC(valve_t1);
	
	valve_stf4 = new StateFormula();
	valve_stf4->addAtom (valve_mode_stuck_open, 1);
 /* gen */
	valve_stf4->setOperat("");

	valve_stf5 = new StateFormula();
	valve_stf5->addAtom (valve_mode_stuck_open, 1);
 /* gen */
	valve_stf5->setOperat("");

	valve_t2 = new Transition(valve_stf4, valve_stf5, "Nominal", 1, 0, 1);
valve_t2->trans_id = 2;
	
	addTransitionToC(valve_t2);
	
	valve_stf6 = new StateFormula();
	valve_stf6->addAtom (valve_mode_stuck_closed, 1);
 /* gen */
	valve_stf6->setOperat("");

	valve_stf7 = new StateFormula();
	valve_stf7->addAtom (valve_mode_stuck_closed, 1);
 /* gen */
	valve_stf7->setOperat("");

	valve_t3 = new Transition(valve_stf6, valve_stf7, "Nominal", 1, 0, 1);
valve_t3->trans_id = 3;
	
	addTransitionToC(valve_t3);
	
	valve_stf8 = new StateFormula();
	valve_stf8->addAtom (valve_mode_closed, 1);
 /* gen */
valve_stf8->addAtom ((*cmpin->atoms)["vdu_cmdout_open"], 0);
 /* gen */
	valve_stf8->setOperat("and");

	valve_stf9 = new StateFormula();
	valve_stf9->addAtom (valve_mode_closed, 1);
 /* gen */
	valve_stf9->setOperat("");

	valve_t4 = new Transition(valve_stf8, valve_stf9, "Nominal", 0.99, 0, 1);
valve_t4->trans_id = 4;
	
	addTransitionToC(valve_t4);
	
	valve_stf10 = new StateFormula();
	valve_stf10->addAtom (valve_mode_open, 1);
 /* gen */
valve_stf10->addAtom ((*cmpin->atoms)["vdu_cmdout_close"], 0);
 /* gen */
	valve_stf10->setOperat("and");

	valve_stf11 = new StateFormula();
	valve_stf11->addAtom (valve_mode_open, 1);
 /* gen */
	valve_stf11->setOperat("");

	valve_t5 = new Transition(valve_stf10, valve_stf11, "Nominal", 0.99, 0, 1);
valve_t5->trans_id = 5;
	
	addTransitionToC(valve_t5);
	
	valve_stf12 = new StateFormula();
valve_stf12->addAtom ((*cmpin->atoms)["vdu_cmdout_close"], 1);
 /* gen */
	valve_stf12->addAtom (valve_mode_open, 1);
 /* gen */
	valve_stf12->setOperat("and");

	valve_stf13 = new StateFormula();
	valve_stf13->addAtom (valve_mode_closed, 1);
 /* gen */
	valve_stf13->setOperat("");

	valve_t6 = new Transition(valve_stf12, valve_stf13, "Nominal", 0.9, 0, 0);
valve_t6->trans_id = 6;
	
	addTransitionToC(valve_t6);
	
	valve_stf14 = new StateFormula();
valve_stf14->addAtom ((*cmpin->atoms)["vdu_cmdout_open"], 1);
 /* gen */
	valve_stf14->addAtom (valve_mode_closed, 1);
 /* gen */
	valve_stf14->setOperat("and");

	valve_stf15 = new StateFormula();
	valve_stf15->addAtom (valve_mode_open, 1);
 /* gen */
	valve_stf15->setOperat("");

	valve_t7 = new Transition(valve_stf14, valve_stf15, "Nominal", 0.9, 0, 0);
valve_t7->trans_id = 7;
	
	addTransitionToC(valve_t7);
	
}
