#include "vdu_rt.h"

using namespace std;

void startinit (Scheduler* sMM) {

	VDU = new vdu("vdu", 0, 0);
	VDU->type = "vdu";
	VDU->var_name = "VDU";
	V1 = new valve("v1", VDU->cmd_out, 0);
	V1->type = "valve";
	V1->var_name = "V1";
	V2 = new valve("v2", VDU->cmd_out, 0);
	V2->type = "valve";
	V2->var_name = "V2";
	sMM->addComp(VDU);
	sMM->addComp(V1);
	sMM->addComp(V2);

	Clause* cl1 = new Clause (V1);
	cl1->addAtomRef(V1->valve_vflow_nonzero, true);
	cl1->addAtomRef(V1->valve_vflow_zero, true);
	cl1->setInternal(1);
	V1->valve_vflow->internal_clauses->push_back(cl1);
sMM->cls->push_back (cl1);
	
	Clause* cl2 = new Clause (V1);
	cl2->addAtomRef(V1->valve_vflow_nonzero, false);
	cl2->addAtomRef(V1->valve_vflow_zero, false);
	cl2->setInternal(1);
	V1->valve_vflow->internal_clauses->push_back(cl2);
sMM->cls->push_back (cl2);
	
	Clause* cl3 = new Clause (V1);
	cl3->addAtomRef(V1->valve_mode_open, true);
	cl3->addAtomRef(V1->valve_mode_closed, true);
	cl3->setInternal(1);
	V1->valve_mode->internal_clauses->push_back(cl3);
sMM->cls->push_back (cl3);
	
	Clause* cl4 = new Clause (V1);
	cl4->addAtomRef(V1->valve_mode_stuck_open, true);
	cl4->addAtomRef(V1->valve_mode_closed, true);
	cl4->setInternal(1);
	V1->valve_mode->internal_clauses->push_back(cl4);
sMM->cls->push_back (cl4);
	
	Clause* cl5 = new Clause (V1);
	cl5->addAtomRef(V1->valve_mode_stuck_closed, true);
	cl5->addAtomRef(V1->valve_mode_closed, true);
	cl5->setInternal(1);
	V1->valve_mode->internal_clauses->push_back(cl5);
sMM->cls->push_back (cl5);
	
	Clause* cl6 = new Clause (V1);
	cl6->addAtomRef(V1->valve_mode_stuck_open, true);
	cl6->addAtomRef(V1->valve_mode_open, true);
	cl6->setInternal(1);
	V1->valve_mode->internal_clauses->push_back(cl6);
sMM->cls->push_back (cl6);
	
	Clause* cl7 = new Clause (V1);
	cl7->addAtomRef(V1->valve_mode_stuck_closed, true);
	cl7->addAtomRef(V1->valve_mode_open, true);
	cl7->setInternal(1);
	V1->valve_mode->internal_clauses->push_back(cl7);
sMM->cls->push_back (cl7);
	
	Clause* cl8 = new Clause (V1);
	cl8->addAtomRef(V1->valve_mode_stuck_closed, true);
	cl8->addAtomRef(V1->valve_mode_stuck_open, true);
	cl8->setInternal(1);
	V1->valve_mode->internal_clauses->push_back(cl8);
sMM->cls->push_back (cl8);
	
	Clause* cl9 = new Clause (V1);
	cl9->addAtomRef(V1->valve_mode_stuck_closed, false);
	cl9->addAtomRef(V1->valve_mode_stuck_open, false);
	cl9->addAtomRef(V1->valve_mode_open, false);
	cl9->addAtomRef(V1->valve_mode_closed, false);
	cl9->setInternal(1);
	V1->valve_mode->internal_clauses->push_back(cl9);
sMM->cls->push_back (cl9);
	
	Clause* cl10 = new Clause (V1);
	cl10->addAtomRef(V1->valve_mode_stuck_closed, true);
	cl10->addAtomRef(V1->valve_vflow_zero, false);
	cl10->setInternal(0);
	V1->external_clauses->push_back(cl10);
	sMM->cls->push_back (cl10);
	
	Clause* cl11 = new Clause (V1);
	cl11->addAtomRef(V1->valve_mode_closed, true);
	cl11->addAtomRef(V1->valve_vflow_zero, false);
	cl11->setInternal(0);
	V1->external_clauses->push_back(cl11);
	sMM->cls->push_back (cl11);
	
	Clause* cl12 = new Clause (V1);
	cl12->addAtomRef(V1->valve_mode_stuck_open, true);
	cl12->addAtomRef(V1->valve_vflow_nonzero, false);
	cl12->setInternal(0);
	V1->external_clauses->push_back(cl12);
	sMM->cls->push_back (cl12);
	
	Clause* cl13 = new Clause (V1);
	cl13->addAtomRef(V1->valve_mode_open, true);
	cl13->addAtomRef(V1->valve_vflow_nonzero, false);
	cl13->setInternal(0);
	V1->external_clauses->push_back(cl13);
	sMM->cls->push_back (cl13);
	
	Clause* cl14 = new Clause (V2);
	cl14->addAtomRef(V2->valve_vflow_nonzero, true);
	cl14->addAtomRef(V2->valve_vflow_zero, true);
	cl14->setInternal(1);
	V2->valve_vflow->internal_clauses->push_back(cl14);
sMM->cls->push_back (cl14);
	
	Clause* cl15 = new Clause (V2);
	cl15->addAtomRef(V2->valve_vflow_nonzero, false);
	cl15->addAtomRef(V2->valve_vflow_zero, false);
	cl15->setInternal(1);
	V2->valve_vflow->internal_clauses->push_back(cl15);
sMM->cls->push_back (cl15);
	
	Clause* cl16 = new Clause (V2);
	cl16->addAtomRef(V2->valve_mode_open, true);
	cl16->addAtomRef(V2->valve_mode_closed, true);
	cl16->setInternal(1);
	V2->valve_mode->internal_clauses->push_back(cl16);
sMM->cls->push_back (cl16);
	
	Clause* cl17 = new Clause (V2);
	cl17->addAtomRef(V2->valve_mode_stuck_open, true);
	cl17->addAtomRef(V2->valve_mode_closed, true);
	cl17->setInternal(1);
	V2->valve_mode->internal_clauses->push_back(cl17);
sMM->cls->push_back (cl17);
	
	Clause* cl18 = new Clause (V2);
	cl18->addAtomRef(V2->valve_mode_stuck_closed, true);
	cl18->addAtomRef(V2->valve_mode_closed, true);
	cl18->setInternal(1);
	V2->valve_mode->internal_clauses->push_back(cl18);
sMM->cls->push_back (cl18);
	
	Clause* cl19 = new Clause (V2);
	cl19->addAtomRef(V2->valve_mode_stuck_open, true);
	cl19->addAtomRef(V2->valve_mode_open, true);
	cl19->setInternal(1);
	V2->valve_mode->internal_clauses->push_back(cl19);
sMM->cls->push_back (cl19);
	
	Clause* cl20 = new Clause (V2);
	cl20->addAtomRef(V2->valve_mode_stuck_closed, true);
	cl20->addAtomRef(V2->valve_mode_open, true);
	cl20->setInternal(1);
	V2->valve_mode->internal_clauses->push_back(cl20);
sMM->cls->push_back (cl20);
	
	Clause* cl21 = new Clause (V2);
	cl21->addAtomRef(V2->valve_mode_stuck_closed, true);
	cl21->addAtomRef(V2->valve_mode_stuck_open, true);
	cl21->setInternal(1);
	V2->valve_mode->internal_clauses->push_back(cl21);
sMM->cls->push_back (cl21);
	
	Clause* cl22 = new Clause (V2);
	cl22->addAtomRef(V2->valve_mode_stuck_closed, false);
	cl22->addAtomRef(V2->valve_mode_stuck_open, false);
	cl22->addAtomRef(V2->valve_mode_open, false);
	cl22->addAtomRef(V2->valve_mode_closed, false);
	cl22->setInternal(1);
	V2->valve_mode->internal_clauses->push_back(cl22);
sMM->cls->push_back (cl22);
	
	Clause* cl23 = new Clause (V2);
	cl23->addAtomRef(V2->valve_mode_stuck_closed, true);
	cl23->addAtomRef(V2->valve_vflow_zero, false);
	cl23->setInternal(0);
	V2->external_clauses->push_back(cl23);
	sMM->cls->push_back (cl23);
	
	Clause* cl24 = new Clause (V2);
	cl24->addAtomRef(V2->valve_mode_closed, true);
	cl24->addAtomRef(V2->valve_vflow_zero, false);
	cl24->setInternal(0);
	V2->external_clauses->push_back(cl24);
	sMM->cls->push_back (cl24);
	
	Clause* cl25 = new Clause (V2);
	cl25->addAtomRef(V2->valve_mode_stuck_open, true);
	cl25->addAtomRef(V2->valve_vflow_nonzero, false);
	cl25->setInternal(0);
	V2->external_clauses->push_back(cl25);
	sMM->cls->push_back (cl25);
	
	Clause* cl26 = new Clause (V2);
	cl26->addAtomRef(V2->valve_mode_open, true);
	cl26->addAtomRef(V2->valve_vflow_nonzero, false);
	cl26->setInternal(0);
	V2->external_clauses->push_back(cl26);
	sMM->cls->push_back (cl26);
	
	Clause* cl27 = new Clause (VDU);
	cl27->addAtomRef(VDU->vdu_cmdin_on, true);
	cl27->addAtomRef(VDU->vdu_cmdin_none, true);
	cl27->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl27);
sMM->cls->push_back (cl27);
	
	Clause* cl28 = new Clause (VDU);
	cl28->addAtomRef(VDU->vdu_cmdin_off, true);
	cl28->addAtomRef(VDU->vdu_cmdin_none, true);
	cl28->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl28);
sMM->cls->push_back (cl28);
	
	Clause* cl29 = new Clause (VDU);
	cl29->addAtomRef(VDU->vdu_cmdin_open, true);
	cl29->addAtomRef(VDU->vdu_cmdin_none, true);
	cl29->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl29);
sMM->cls->push_back (cl29);
	
	Clause* cl30 = new Clause (VDU);
	cl30->addAtomRef(VDU->vdu_cmdin_close, true);
	cl30->addAtomRef(VDU->vdu_cmdin_none, true);
	cl30->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl30);
sMM->cls->push_back (cl30);
	
	Clause* cl31 = new Clause (VDU);
	cl31->addAtomRef(VDU->vdu_cmdin_reset, true);
	cl31->addAtomRef(VDU->vdu_cmdin_none, true);
	cl31->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl31);
sMM->cls->push_back (cl31);
	
	Clause* cl32 = new Clause (VDU);
	cl32->addAtomRef(VDU->vdu_cmdin_off, true);
	cl32->addAtomRef(VDU->vdu_cmdin_on, true);
	cl32->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl32);
sMM->cls->push_back (cl32);
	
	Clause* cl33 = new Clause (VDU);
	cl33->addAtomRef(VDU->vdu_cmdin_open, true);
	cl33->addAtomRef(VDU->vdu_cmdin_on, true);
	cl33->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl33);
sMM->cls->push_back (cl33);
	
	Clause* cl34 = new Clause (VDU);
	cl34->addAtomRef(VDU->vdu_cmdin_close, true);
	cl34->addAtomRef(VDU->vdu_cmdin_on, true);
	cl34->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl34);
sMM->cls->push_back (cl34);
	
	Clause* cl35 = new Clause (VDU);
	cl35->addAtomRef(VDU->vdu_cmdin_reset, true);
	cl35->addAtomRef(VDU->vdu_cmdin_on, true);
	cl35->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl35);
sMM->cls->push_back (cl35);
	
	Clause* cl36 = new Clause (VDU);
	cl36->addAtomRef(VDU->vdu_cmdin_open, true);
	cl36->addAtomRef(VDU->vdu_cmdin_off, true);
	cl36->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl36);
sMM->cls->push_back (cl36);
	
	Clause* cl37 = new Clause (VDU);
	cl37->addAtomRef(VDU->vdu_cmdin_close, true);
	cl37->addAtomRef(VDU->vdu_cmdin_off, true);
	cl37->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl37);
sMM->cls->push_back (cl37);
	
	Clause* cl38 = new Clause (VDU);
	cl38->addAtomRef(VDU->vdu_cmdin_reset, true);
	cl38->addAtomRef(VDU->vdu_cmdin_off, true);
	cl38->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl38);
sMM->cls->push_back (cl38);
	
	Clause* cl39 = new Clause (VDU);
	cl39->addAtomRef(VDU->vdu_cmdin_close, true);
	cl39->addAtomRef(VDU->vdu_cmdin_open, true);
	cl39->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl39);
sMM->cls->push_back (cl39);
	
	Clause* cl40 = new Clause (VDU);
	cl40->addAtomRef(VDU->vdu_cmdin_reset, true);
	cl40->addAtomRef(VDU->vdu_cmdin_open, true);
	cl40->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl40);
sMM->cls->push_back (cl40);
	
	Clause* cl41 = new Clause (VDU);
	cl41->addAtomRef(VDU->vdu_cmdin_reset, true);
	cl41->addAtomRef(VDU->vdu_cmdin_close, true);
	cl41->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl41);
sMM->cls->push_back (cl41);
	
	Clause* cl42 = new Clause (VDU);
	cl42->addAtomRef(VDU->vdu_cmdin_reset, false);
	cl42->addAtomRef(VDU->vdu_cmdin_close, false);
	cl42->addAtomRef(VDU->vdu_cmdin_open, false);
	cl42->addAtomRef(VDU->vdu_cmdin_off, false);
	cl42->addAtomRef(VDU->vdu_cmdin_on, false);
	cl42->addAtomRef(VDU->vdu_cmdin_none, false);
	cl42->setInternal(1);
	VDU->vdu_cmdin->internal_clauses->push_back(cl42);
sMM->cls->push_back (cl42);
	
	Clause* cl43 = new Clause (VDU);
	cl43->addAtomRef(VDU->vdu_cmdout_open, true);
	cl43->addAtomRef(VDU->vdu_cmdout_none, true);
	cl43->setInternal(1);
	VDU->vdu_cmdout->internal_clauses->push_back(cl43);
sMM->cls->push_back (cl43);
	
	Clause* cl44 = new Clause (VDU);
	cl44->addAtomRef(VDU->vdu_cmdout_close, true);
	cl44->addAtomRef(VDU->vdu_cmdout_none, true);
	cl44->setInternal(1);
	VDU->vdu_cmdout->internal_clauses->push_back(cl44);
sMM->cls->push_back (cl44);
	
	Clause* cl45 = new Clause (VDU);
	cl45->addAtomRef(VDU->vdu_cmdout_close, true);
	cl45->addAtomRef(VDU->vdu_cmdout_open, true);
	cl45->setInternal(1);
	VDU->vdu_cmdout->internal_clauses->push_back(cl45);
sMM->cls->push_back (cl45);
	
	Clause* cl46 = new Clause (VDU);
	cl46->addAtomRef(VDU->vdu_cmdout_close, false);
	cl46->addAtomRef(VDU->vdu_cmdout_open, false);
	cl46->addAtomRef(VDU->vdu_cmdout_none, false);
	cl46->setInternal(1);
	VDU->vdu_cmdout->internal_clauses->push_back(cl46);
sMM->cls->push_back (cl46);
	
	Clause* cl47 = new Clause (VDU);
	cl47->addAtomRef(VDU->vdu_mode_on, true);
	cl47->addAtomRef(VDU->vdu_mode_off, true);
	cl47->setInternal(1);
	VDU->vdu_mode->internal_clauses->push_back(cl47);
sMM->cls->push_back (cl47);
	
	Clause* cl48 = new Clause (VDU);
	cl48->addAtomRef(VDU->vdu_mode_failed, true);
	cl48->addAtomRef(VDU->vdu_mode_off, true);
	cl48->setInternal(1);
	VDU->vdu_mode->internal_clauses->push_back(cl48);
sMM->cls->push_back (cl48);
	
	Clause* cl49 = new Clause (VDU);
	cl49->addAtomRef(VDU->vdu_mode_unknown, true);
	cl49->addAtomRef(VDU->vdu_mode_off, true);
	cl49->setInternal(1);
	VDU->vdu_mode->internal_clauses->push_back(cl49);
sMM->cls->push_back (cl49);
	
	Clause* cl50 = new Clause (VDU);
	cl50->addAtomRef(VDU->vdu_mode_failed, true);
	cl50->addAtomRef(VDU->vdu_mode_on, true);
	cl50->setInternal(1);
	VDU->vdu_mode->internal_clauses->push_back(cl50);
sMM->cls->push_back (cl50);
	
	Clause* cl51 = new Clause (VDU);
	cl51->addAtomRef(VDU->vdu_mode_unknown, true);
	cl51->addAtomRef(VDU->vdu_mode_on, true);
	cl51->setInternal(1);
	VDU->vdu_mode->internal_clauses->push_back(cl51);
sMM->cls->push_back (cl51);
	
	Clause* cl52 = new Clause (VDU);
	cl52->addAtomRef(VDU->vdu_mode_unknown, true);
	cl52->addAtomRef(VDU->vdu_mode_failed, true);
	cl52->setInternal(1);
	VDU->vdu_mode->internal_clauses->push_back(cl52);
sMM->cls->push_back (cl52);
	
	Clause* cl53 = new Clause (VDU);
	cl53->addAtomRef(VDU->vdu_mode_unknown, false);
	cl53->addAtomRef(VDU->vdu_mode_failed, false);
	cl53->addAtomRef(VDU->vdu_mode_on, false);
	cl53->addAtomRef(VDU->vdu_mode_off, false);
	cl53->setInternal(1);
	VDU->vdu_mode->internal_clauses->push_back(cl53);
sMM->cls->push_back (cl53);
	
	Clause* cl54 = new Clause (VDU);
	cl54->addAtomRef(VDU->vdu_mode_failed, true);
	cl54->addAtomRef(VDU->vdu_cmdout_none, false);
	cl54->setInternal(0);
	VDU->external_clauses->push_back(cl54);
	sMM->cls->push_back (cl54);
	
	Clause* cl55 = new Clause (VDU);
	cl55->addAtomRef(VDU->vdu_mode_off, true);
	cl55->addAtomRef(VDU->vdu_cmdout_none, false);
	cl55->setInternal(0);
	VDU->external_clauses->push_back(cl55);
	sMM->cls->push_back (cl55);
	
	Clause* cl56 = new Clause (VDU);
	cl56->addAtomRef(VDU->vdu_mode_on, true);
	cl56->addAtomRef(VDU->vdu_cmdin_none, true);
	cl56->addAtomRef(VDU->vdu_cmdout_none, false);
	cl56->setInternal(0);
	VDU->external_clauses->push_back(cl56);
	sMM->cls->push_back (cl56);
	
	Clause* cl57 = new Clause (VDU);
	cl57->addAtomRef(VDU->vdu_mode_on, true);
	cl57->addAtomRef(VDU->vdu_cmdin_reset, true);
	cl57->addAtomRef(VDU->vdu_cmdout_none, false);
	cl57->setInternal(0);
	VDU->external_clauses->push_back(cl57);
	sMM->cls->push_back (cl57);
	
	Clause* cl58 = new Clause (VDU);
	cl58->addAtomRef(VDU->vdu_mode_on, true);
	cl58->addAtomRef(VDU->vdu_cmdin_off, true);
	cl58->addAtomRef(VDU->vdu_cmdout_none, false);
	cl58->setInternal(0);
	VDU->external_clauses->push_back(cl58);
	sMM->cls->push_back (cl58);
	
	Clause* cl59 = new Clause (VDU);
	cl59->addAtomRef(VDU->vdu_mode_on, true);
	cl59->addAtomRef(VDU->vdu_cmdin_on, true);
	cl59->addAtomRef(VDU->vdu_cmdout_none, false);
	cl59->setInternal(0);
	VDU->external_clauses->push_back(cl59);
	sMM->cls->push_back (cl59);
	
	Clause* cl60 = new Clause (VDU);
	cl60->addAtomRef(VDU->vdu_mode_on, true);
	cl60->addAtomRef(VDU->vdu_cmdin_close, true);
	cl60->addAtomRef(VDU->vdu_cmdout_close, false);
	cl60->setInternal(0);
	VDU->external_clauses->push_back(cl60);
	sMM->cls->push_back (cl60);
	
	Clause* cl61 = new Clause (VDU);
	cl61->addAtomRef(VDU->vdu_mode_on, true);
	cl61->addAtomRef(VDU->vdu_cmdin_open, true);
	cl61->addAtomRef(VDU->vdu_cmdout_open, false);
	cl61->setInternal(0);
	VDU->external_clauses->push_back(cl61);
	sMM->cls->push_back (cl61);
	/* cross-reference code */
		V2->valve_t4->refAtomPre (0, VDU->vdu_cmdout_open);
	V2->valve_t5->refAtomPre (0, VDU->vdu_cmdout_close);
	V2->valve_t6->refAtomPre (1, VDU->vdu_cmdout_close);
	V2->valve_t7->refAtomPre (1, VDU->vdu_cmdout_open);

	dico = (variable*) new_malloc (0*sizeof (variable));
	condi = (condition*) new_malloc (12*sizeof (condition));
	condi[0] = V1->c_5;
	condi[1] = V1->c_6;
	condi[2] = V1->c_7;
	condi[3] = V1->c_8;
	condi[4] = V2->c_9;
	condi[5] = V2->c_10;
	condi[6] = V2->c_11;
	condi[7] = V2->c_12;
	condi[8] = VDU->c_1;
	condi[9] = VDU->c_2;
	condi[10] = VDU->c_3;
	condi[11] = VDU->c_4;
	vdu_rt = (runtime) new_malloc (sizeof (s_runtime));
	vdu_rt->appli = "vdu";
	vdu_rt->num = 0;
	vdu_rt->ts = 1;
	vdu_rt->dts = 0;
	vdu_rt->twc = 300;
	vdu_rt->nvar = 0;
	vdu_rt->dico = dico;
	vdu_rt->nin = 0;
	vdu_rt->in = NULL;
	vdu_rt->inval = NULL;
	vdu_rt->ndisp = 0;
	vdu_rt->disp = NULL;
	vdu_rt->dispinfval = NULL;
	vdu_rt->dispsupval = NULL;
	vdu_rt->ndispall = 0;
	vdu_rt->dispall = NULL;
	vdu_rt->nmes = 0;
	vdu_rt->mes = NULL;
	vdu_rt->mesval = NULL;
	vdu_rt->lowalarm = NULL;
	vdu_rt->highalarm = NULL;
	vdu_rt->lowmisb = NULL;
	vdu_rt->highmisb = NULL;
	vdu_rt->misb = NULL;
	vdu_rt->ntemp = 0;
	vdu_rt->temp = NULL;
	vdu_rt->nuntemp = 0;
	vdu_rt->untemp = NULL;
	vdu_rt->nifl = 0;
	vdu_rt->infl = NULL;
	vdu_rt->condin = NULL;
	vdu_rt->condout = NULL;
	vdu_rt->ncg = 0;
	vdu_rt->cg = NULL;
	vdu_rt->maxDepth = 0;
	vdu_rt->nit = 0;
	vdu_rt->iv = NULL;
	vdu_rt->ngv = 0;
	vdu_rt->vgv = NULL;
	vdu_rt->ngc = 0;
	vdu_rt->glc = NULL;
	vdu_rt->inag = NULL;
	vdu_rt->ncdc = 0;
	vdu_rt->cdc = NULL;
	vdu_rt->valSpc = NULL;
	vdu_rt->inac = NULL;
	vdu_rt->mfc = 0;
	vdu_rt->mfc = NULL;
	vdu_rt->inited = 0;
	vdu_rt->runGC = 0;
	vdu_rt->cumTime = 0;
	vdu_rt->prec = 0;
	vdu_rt->onlyFaultIso = 0;
	vdu_rt->numMisb = 0;
	vdu_rt->numOk = 0;
	vdu_rt->mbVA = NULL;
	vdu_rt->okVA = NULL;
	vdu_rt->sfVA = NULL;
	vdu_rt->oldNumMisb = 0;
	vdu_rt->oldMisbVarArray = NULL;
	vdu_rt->numNodesHST = 0;vdu_rt->ncondi = 12;
	vdu_rt->condi = condi;
	vdu_rt->bridgeEvents = NULL;
	vdu_rt->bridgeConds = NULL;
	vdu_rt->bridgeTransitions = NULL;vdu_rt->bridgeConflicts = NULL;
	createLeafListcaen (&vdu_rt->HSTree);
	createConflictSet (&vdu_rt->softConflictListcaen);
	vdu_rt->diagOut = NULL;
	
/* remove next line if linking several applications 		       together */
koala_rt=vdu_rt;
	}
bool env_opti = 1;
long guards_int = 0;
	int Trajectory::twd = 5;
	long h_pi = 0;
	string model_name = "vdu";
	