/*********************************************************************/
/*                                                                   */
/*                          --- optim.h ---                          */
/*                                                                   */
/* fct: module des en-tetes des procedures et fonctions utilisees    */
/*      par toutes les methodes d'optimisation non-lineaire.         */
/*                                                                   */
/* aut: Francois Dufour (LAAS)                                       */
/*                                                                   */
/* ver: 22 fevrier 1994                                              */
/*                                                                   */
/*********************************************************************/

/*** definitions globales du module ***/

#define FALSE	0
#define TRUE	1

/*** declaration des types globaux ***/
/*
 * boolean values
 */
#ifndef TY_BOOLEAN
#define TY_BOOLEAN
typedef enum boolVal {CE_FALSE, CE_TRUE} boolean;
#endif
/*typedef int boolean;*/

/*** declaration des procedures et fonctions ***/

double Optim_ran0
(
int *idum   /* ptr d'un nb entier quelconque: negatif pour initialiser la fonction */
);

void Optim_tri_index
(
int     n,         /* dimension du vecteur */
double *vecteur,   /* ptr du vecteur a trier */
int    *index      /* ptr du vecteur des indices */
);

double Optim_longvec_norm
(
int     dimX,     /* dimension du vecteur            */
double *Xini,     /* ptr du point initial du vecteur */
double *Xfin,     /* ptr du point final du vecteur   */
double *delta_X   /* ptr des largeurs des domaines   */
);

boolean iveridom
(
int    *n,      /* ptr du nombre de parametres de commande   */
double *X,      /* ptr du vecteur des parametres de commande */
double *Xmin,   /* ptr des bornes minimales du domaine des X */
double *Xmax    /* ptr des bornes maximales du domaine des X */
);

boolean iveridom_
(
int    *n,      /* ptr du nombre de parametres de commande   */
double *X,      /* ptr du vecteur des parametres de commande */
double *Xmin,   /* ptr des bornes minimales du domaine des X */
double *Xmax    /* ptr des bornes maximales du domaine des X */
);

double drandom_
(
int *idum   /* ptr d'un nb entier quelconque: negatif pour initialiser la fonction */
);

