/**
 * Config file for koala.
 */

#ifndef CONFIG_H
#define CONFIG_H

#include "../config.h"

#define GNU

/* for a verbose compilation. */
#define VERBOSE_COMPIL

/* debug of the itms. */
#define DEBUG_ITMS

/* debug state of the diagnoser. */
#define DEBUG_DIAG

/* if define, the system handles diagnosis of multiple commands transition. */
/*#define HANDLE_TCM*/

/* if an itms is needed in the supervisor 
(required for prime implicants computation) */
#define SUP_ITMS

/* if define, the system will used built-in probabilities. */
#define PROBAS

/* makes use of bdds for highly accurate probabilities computation. Require PROBAS. */
#ifdef PROBAS
#ifdef HAVE_LIBBDD
/*#define USE_BDD */
#endif
#endif

/* if define, the itms will use entropy to focus on most promising solutions.*/
#ifdef PROBAS
#define ENTROPY
#endif

/* if benchmarks files are required. */
#define BENCHMK

/* if reconfiguration is activated or not. */
#define RECONF

/* if discrete only models are accepted or not. */
#define DISCRETE_ONLY

/* if the optimization of envelopes is compiled in or not */
#define ENV_OPTI

/***** external applications *****/
/* if dot is present */
#define HAVE_DOT
/* if gv is present */
#define HAVE_GV

#endif
