/*    
 *  Copyright 2000, 2001, 2002 Emmanuel Benazera  
 *
 *  This file is part of Koala.
 *
 *  Koala is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Koala is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Koala; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* tools for modeling, testing and debugging. */

#ifndef MODELTOOLS_H
#define MODELTOOLS_H

#include <string>
#include <map>
#include "../behav/Comprt.h"
#include "../behav/Trajectoryrt.h"

/**
 * Make a graph of a component, i.e. a file in dot form.
 */
void toDot(Comp* co);

/**
 * Make a graph node name with specific label.
 */
string makeNodeNameWithLabel(Atom* at, const std::string &timestep);
/**
 * Make a graph node name without label (for search operations).
 */
string makeNodeName(Atom* at, const std::string &timestep);

/**
 * Make a graph of a trajectory, i.e. a file in dot form.
 */
void toDot(Trajectory* tr, const std::string &name);

#endif
